(define export '(export
                 (forms doc-acc-invoice
                        arch-acc-invoice)))

(define ds-acc-invoice
  (quasiquote
   (dataset
    (extend
     (AddNum
      (mode extend)
      (index 0)
      (type ShortString)
      (caption "К плат.-расч. док. №"))
     (AddDate
      (mode extend)
      (index 1)
      (type Date)
      (caption "от"))
     (AddNote
      (mode extend)
      (index 2)
      (type LongString)
      (caption "Примечание")
      (tags template)))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 AddNum AddDate AddNote)))))

(define-doc doc-acc-invoice
  (quasiquote
   (form
    (caption "Счет-фактура")
    (dataset ds-acc-invoice)
    (archive arch-acc-invoice)
    (extend DocPriceFill)
    (fill
     (caption "счету-фактуре")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [NDSE "НДС"]
                [Sum "Сумма"]
				[ModelGroupName "Группа" 100])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner)
    (visual
     (Name
      (numerator 1)
      (caption "Счет-фактура №"))
     (Date
      (caption "от"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Продавец")
     ,(ctrl-firm 'Partner $doc 'duties-std "Покупатель")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h (v Firm (h Name Date)) 
                  (v Partner AddNote))
               (h AddNum AddDate CurrCtl)
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Firm Name AddNum] [Partner AddNote]))
    (styles ([Mini Precision Name AddNum])))))

(define arch-acc-invoice (arch-form "Архив счетов-фактур" 'doc-acc-invoice #t #t))
