(define export '(export
                 (forms doc-acc-order
                        arch-acc-order)))

(define ds-acc-order
  (quasiquote
   (dataset
    (extend
     (SubCode
      (mode extend)
      (index 0)
      (type LongString))
     (AltDep
      (mode extend)
      (index 1)
      (type LongString))
     (AnAccnt
      (mode extend)
      (index 2)
      (type LongString))
     (Credit
      (mode extend)
      (index 3)
      (type LongString))
     (DestCode
      (mode extend)
      (index 4)
      (type LongString))
     (Basis
      (mode extend)
      (index 5)
      (type LongString)
      (caption "Основание")
      (tags template))
     (Applet
      (mode extend)
      (index 6)
      (type LongString)
      (caption "Приложение")
      (tags template))
     (ByDoc
      (mode extend)
      (index 7)
      (type LongString)
      (caption "По документу")
      (tags template)))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 SubCode AltDep AnAccnt Credit DestCode Basis Applet ByDoc)))))

(define-doc doc-acc-order
  (quasiquote
   (form
    (caption "Расходный ордер")
    (dataset ds-acc-order)
    (archive arch-acc-order)
    (fill
     (caption "расходному ордеру")
     (require Nonexistent)
     (provide Payment))
    (controls
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Partner $doc 'Person '(caption "Через кого")))
    (visual
     (Name
      (numerator 1)
      (caption "Расходный ордер №")
      (style Mini))
     (Date
      (caption "от"))
     (Sum
      (caption "Сумма"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Организация")
     ,(ctrl-firm 'Partner $doc 'duties-std "Получил")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Name Date)
               (h (v "Код структурного\nподразделения" SubCode) "|"
                  (v "Корреспонди-\nрующий счет" AltDep) "|"
                  (v "Код аналитичес-\nкого учета" AnAccnt) "|"
                  (v "Кредит\n " Credit) "|"
                  (v "Код целевого\nназначения" DestCode))
               Firm Partner Person
               Sum
               Basis Applet ByDoc))
    (groups ([Firm Name Partner Sum Basis Applet ByDoc Person]))
    (styles ([Mini Precision SubCode AltDep AnAccnt Credit DestCode Sum])))))

(define ds-acc-order-arch-docs
  (quasiquote
   (dataset
    (extend
     (PayState
      (mode raw)
      (type ImageName)
      (caption "PayState")
      (raw "(SELECT \"oState\" FROM \"pDocGetPaymentState\"(r_Doc.\"fObject\"))"))
     (PaySum
      (mode raw)
      (type Money)
      (caption "PaySum")
      (raw "(SELECT SUM(\"fSum\") FROM \"tPayment\" WHERE \"fDoc\" = r_Doc.\"fObject\")"))
     (PersonFIO
      (mode raw)
      (type ExtString)
      (caption "Через кого")
      (raw ,(mix "(select" br
                 "    p.\"fSecondName\" ||" br
                 "      coalesce((' ' || nullif(substring(p.\"fFirstName\" from 1 for 1), '') || '.'), '') ||" br
                 "      coalesce((' ' || nullif(substring(p.\"fLastName\" from 1 for 1), '') || '.'), '')" br
                 "   from" br
                 "    \"tMutualRef\" r_Person" br
                 "   join" br
                 "    \"tPeople\" p on (p.\"fObject\" = r_Person.\"fValue\")" br
                 "   where" br
                 "    (r_Person.\"fOwner0\" = r_Doc.\"fObject\") and" br
                 "    (r_Person.\"fOwner1\" = r_Doc.\"fPartner\") and" br
                 "    (r_Person.\"fName\" = 'Person.doc-acc-order'))")))
     )
    (fields (Doc Type (Firm ShortName) (Partner ShortName) Date Name Num Sum PaySum PayState PersonFIO Mark))
    (where (Type = "'doc-acc-order'")
           [nnvl Firm = :aFirm]
           [nnvl Partner = :aPartner]
           [nnvl Date >= :aFrom]
           [nnvl Date <= :aTo]
           [nnvl :aPayState CONTAINING PayState]))))

(define arch-acc-order (arch-form "Архив расходных ордеров" 'doc-acc-order #f #f
                                  '(ds-docs ds-acc-order-arch-docs)
                                  '(column-person-fio #t)))
