(define export '(export
                 (forms doc-act-exec-works
                        arch-act-exec-works)))

(define ds-act-exec-works
  (quasiquote
   (dataset
    (extend
     (Base
      (mode extend)
      (index 0)
      (type LongString)
      (caption "Основание")
      (tags template)))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Base Sum)))))

(define-doc doc-act-exec-works
  (quasiquote
   (form
    (caption "Акт выполненных работ")
    (dataset ds-act-exec-works)
    (archive arch-act-exec-works)
    (extend DocPriceFill)
    (fill
     (caption "акту выполненных работ")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [NDSE "НДС"]
                [Sum "Сумма"]
                [ModelGroupName "Группа" 100])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'FirmPerson '(caption "Сдал"))
     ,(ctrl-people 'Partner $doc 'PartnerPerson '(caption "Принял")))
    (visual
     (Name
      (numerator 1)
      (caption "Акт №")
      (style Mini))
     (Date
      (caption "от"))
     (Base
      (type String)
      (caption "Примечание"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Продавец")
     ,(ctrl-firm 'Partner $doc 'duties-std "Покупатель")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Firm Partner)
               (h FirmPerson PartnerPerson)
               (h Name Date Base CurrCtl)
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Firm FirmPerson Name] [Partner PartnerPerson Base]))
    (styles ([Mini Precision])))))

(define arch-act-exec-works (arch-form "Архив актов выполненных работ" 'doc-act-exec-works #t #t))
