(define export '(export
                 (forms doc-ann-pay-cash
                        arch-ann-pay-cash)))

(define ds-ann-pay-cash
  (quasiquote
   (dataset
    (extend
     (PaySource
      (mode extend)
      (index 0)
      (type LongString)
      (tags template))
     (OKATO
      (mode extend)
      (index 1)
      (type ShortString)
      (tags template))
     (SYM0
      (mode extend)
      (index 2)
      (type ShortString))
     (SYM1
      (mode extend)
      (index 3)
      (type ShortString))
     (SYM2
      (mode extend)
      (index 4)
      (type ShortString))
     (SYM3
      (mode extend)
      (index 5)
      (type ShortString))
     (SUM0
      (mode extend)
      (index 6)
      (type Money))
     (SUM1
      (mode extend)
      (index 7)
      (type Money))
     (SUM2
      (mode extend)
      (index 8)
      (type Money))
     (SUM3
      (mode extend)
      (index 9)
      (type Money))
     (Debet
      (mode extend)
      (index 10)
      (type Dep)
      (tags template)))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num PaySource Sum
                 OKATO SYM0 SYM1 SYM2 SYM3 SUM0 SUM1 SUM2 SUM3 Debet)))))

(define-doc doc-ann-pay-cash
  (quasiquote
   (form
    (caption "Объявление на взнос наличными")
    (dataset ds-ann-pay-cash)
    (archive arch-ann-pay-cash)
    (controls
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     (SymDecode
      (type Relay)
      (method "advert-symbols")
      (bind ([SYM0 Master SYM0]
             [SUM0 Master SUM0]
             [SYM1 Master SYM1]
             [SUM1 Master SUM1]
             [SYM2 Master SYM2]
             [SUM2 Master SUM2]
             [SYM3 Master SYM3]
             [SUM3 Master SUM3]
             [PaySource Master PaySource]
             [Sum Master Sum])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'Person '(caption "Через кого")))
    (visual
     (Name
      (numerator 1)
      (caption "Объявление №")
      (style Mini))
     (Date
      (caption "от"))
     (PaySource
      (type String)
      (caption "Источник взноса"))
     ,(ctrl-firm 'Firm $doc 'duties-std "От кого")
     ,(ctrl-firm 'Partner $doc 'duties-std "Получатель")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Name Date)
               (h (v Firm Person (h ">Дебет" Debet) Partner (h ">ОКАТО" OKATO) PaySource) "|" (v (h "Cумма" Sum) 
                                                                                                 (h (v "Символ" SYM0 SYM1 SYM2 SYM3) (v "Cумма" SUM0 SUM1 SUM2 SUM3))
                                                                                                 ))
               "--"))
    ;(childs
    ; (setup "Настройка" (v Precision SumMethod)))
    (groups ([Name Firm Partner PaySource Person ">Дебет" ">ОКАТО"]))
    (styles ([Mini Precision Sum SYM0 SYM1 SYM2 SYM3 SUM0 SUM1 SUM2 SUM3])))))

(define arch-ann-pay-cash (arch-form "Архив объявлений на взнос наличными" 'doc-ann-pay-cash #f #f))
