(define export '(export
                 (forms doc-cash-memo
                        arch-cash-memo)))

(define ds-cash-memo
  (quasiquote
   (dataset
    (extend
     (Note
      (mode extend)
      (index 0)
      (type LongString)
      (caption "Примечание")
      (tags template)))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner Date Name Num Note Sum)))))

(define-doc doc-cash-memo
  (quasiquote
   (form
    (caption "Товарный чек")
    (dataset ds-cash-memo)
    (archive arch-cash-memo)
    (extend DocPriceFill)
    (fill
     (caption "товарному чеку")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [NDSE "НДС"]
                [Sum "Сумма"]
                [ModelGroupName "Группа" 100])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,(ctrl-people 'Firm $doc 'FirmPerson '(caption "Подписал")))
    (visual
     (Name
      (numerator 1)
      (caption "Товарный чек №")
      (style Mini))
     (Date
      (caption "от"))
     (Note
      (type String)
      (caption "Примечание"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Продавец")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Firm FirmPerson)
               (h Name Date Note CurrCtl)
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Firm Name] [FirmPerson Note]))
    (styles ([Mini Precision])))))

(define arch-cash-memo (arch-form "Архив товарных чеков" 'doc-cash-memo #t #f '(hide-partner #t)))
