(define export '(export
                 (forms doc-cash-request
                        arch-cash-request)))

(define ds-cash-request
  (quasiquote
   (dataset
    (extend
     (DateIsp
      (mode extend)
      (index 0)
      (type Date)
      (caption "Предельная дата исполнения"))
     (NumBO
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Номер обязательства"))
     (PrIsp
      (mode extend)
      (index 2)
      (type LongString)
      (caption "Приоритет исполнения")))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum DateIsp NumBO PrIsp)))))

(define-doc doc-cash-request
  (quasiquote
   (form
    (caption "Заявка на кассовый расход")
    (dataset ds-cash-request)
    (archive arch-cash-request)
    (controls
     (SubDoc
      (type Grid)
      (dataset ds-subdoc-std)
      (bind ([aDoc Master Object]
             [Precision Master Precision]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [AggSum2 Master Sum]))
      (form form-subdoc-std)
      (columns ([SumT "Сумма в валюте" 100]
                [Sum "Сумма" 80]
                [SumN "Сумма НДС" 80]
                [TypeAP "Пр" 20]
                [OrderPL "Очередность платежа" 150]
                [VidPL "Вид платежа" 150]
                [Purpose "Назначение платежа" 150]))
      )
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm)
    (visual
     (Name
      (numerator 1)
      (caption "Заявка на кассовый расход №")
      (style Mini))
     (Date
      (caption "от"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Наименование клиента")
     )
    (layout (v (h Name Date Firm) 
               (h PrIsp NumBO)
               (h DateIsp CurrCtl)
               SubDoc 
               (h (v "Реквизиты документа - основания" "--"
                     (h "Вид:" "[SubDoc.Current.VidOsn]") 
                     (h "Номер:" "[SubDoc.Current.NumOsn]")
                     (h "Дата:" "[SubDoc.Current.DateOsn]") 
                     (h "Предмет:" "[SubDoc.Current.Osn]")
                     "--"
                     "Расшифровка заявки на кассовый расход" "--"
                     (h "Источник средств:" "[SubDoc.Current.CodeIstKBK]") 
                     (h "Код по БК плательщика:" "[SubDoc.Current.KBKPay.Name]") 
                     (h "Код по БК получателя:" "[SubDoc.Current.KBKRcp.Name]") 
                     (h "Назначение платежа:" "[SubDoc.Current.PurposeKBK]")
                     (h "Примечание:" "[SubDoc.Current.NoteKBK]")
                     ) 
                  "|"
                  (v "Реквизиты налоговых платежей" "--"
                     (h "Статус:" "[SubDoc.Current.PayStatus]") 
                     (h "Код по БК:" "[SubDoc.Current.KDOH.Name]") 
                     (h "Код ОКАТО:" "[SubDoc.Current.OKATO.Name]") 
                     (h "Основание платежа:" "[SubDoc.Current.OsnPL]") 
                     (h "Налоговый период:" "[SubDoc.Current.NalPer]") 
                     (h "Номер документа:" "[SubDoc.Current.NumDok]") 
                     (h "Дата документа:" "[SubDoc.Current.DateDok]") 
                     (h "Тип платежа:" "[SubDoc.Current.TypePL]")
                     "<<250>>"
                     )
                  "|"
                  (v "Реквизиты контрагента" "--"
                     (h "Наименование:" "[SubDoc.Current.Partner.FullName]") 
                     (h "ИНН:" "[SubDoc.Current.Partner.INN]") 
                     (h "КПП:" "[SubDoc.Current.Partner.KPP]") 
                     (h "Лицевой счет:" "[SubDoc.Current.Partner.OfkDep]") 
                     (h "Банковский счет:" "[SubDoc.Current.Partner.RasDep]") 
                     (h "Наименование банка:" "[SubDoc.Current.Partner.Bank]") 
                     (h "БИК банка:" "[SubDoc.Current.Partner.BIK]") 
                     (h "Кор. счет:" "[SubDoc.Current.Partner.CorDep]")
                     )
                  )
               ))
    (childs
     (setup "Настройка" (v Precision)))
    (groups ([Name DateIsp PrIsp] [Firm NumBO]))
    (styles ([Mini Precision])))))

(define arch-cash-request (arch-form "Архив заявок на кассовый расход" 'doc-cash-request #f #f '(export cash-request) '(hide-partner #t)))
