(define export '(export
                 (forms doc-contract-goods
                        arch-contract-goods)))

(define ds-contract-goods
  (quasiquote
   (dataset
    (extend
     (FirmBase
      (mode extend)
      (index 0)
      (type LongString)
      (caption "На основании")
      (tags template))
     (PartnerBase
      (mode extend)
      (index 1)
      (type LongString)
      (caption "На основании")
      (tags template))
     (NDS
      (mode extend)
      (index 2)
      (type Percent)
      (caption "НДС"))
     (Subject
      (mode extend)
      (index 3)
      (type ExtString)
      (caption "Предмет договора")
      (tags template))
     (Note
      (mode extend)
      (index 4)
      (type LongString)
      (caption "Примечание")
      (tags template))
     )
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 FirmBase PartnerBase NDS Subject Note)))))

(define-doc doc-contract-goods
  (quasiquote
   (form
    (caption "Договор с товарами")
    (dataset ds-contract-goods)
    (archive arch-contract-goods)
    (extend DocPriceFill)
    (fill
     (caption "договору с товарами")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [NDSE "НДС"]
                [Sum "Сумма"]
                [ModelGroupName "Группа"])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'FirmPerson '(caption "В лице"))
     ,(ctrl-people 'Partner $doc 'PartnerPerson '(caption "В лице")))
    (visual
     (Name
      (numerator 1)
      (caption "Договор №")
      (style Mini))
     (Date
      (caption "от"))
     ;(Sum
     ; (caption "Сумма"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Сторона 1")
     ,(ctrl-firm 'Partner $doc 'duties-std "Сторона 2")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h (v (h Name Date)
                     Firm
                     FirmPerson
                     FirmBase
                     Subject)
                  (v Note 
                     Partner
                     PartnerPerson
                     PartnerBase
                     CurrCtl))
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Name Firm FirmBase FirmPerson Subject] [Note Partner PartnerBase PartnerPerson Sum]))
    (styles ([Mini Precision]))
    )))

(define arch-contract-goods (arch-form "Архив договоров с товарами" 'doc-contract-goods #t #t))
