(define export '(export
                 (forms doc-contract
                        arch-contract)))

(define ds-contract
  (quasiquote
   (dataset
    (extend
     (FirmBase
      (mode extend)
      (index 0)
      (type LongString)
      (caption "На основании")
      (tags template))
     (PartnerBase
      (mode extend)
      (index 1)
      (type LongString)
      (caption "На основании")
      (tags template))
     (NDS
      (mode extend)
      (index 2)
      (type Percent)
      (caption "НДС"))
     (Subject
      (mode extend)
      (index 3)
      (type ExtString)
      (caption "Предмет договора")
      (tags template))
     (Note
      (mode extend)
      (index 4)
      (type LongString)
      (caption "Примечание")
      (tags template))
     )
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 FirmBase PartnerBase NDS Subject Note)))))

(define-doc doc-contract
  (quasiquote
   (form
    (caption "Договор")
    (dataset ds-contract)
    (archive arch-contract)
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'FirmPerson '(caption "В лице"))
     ,(ctrl-people 'Partner $doc 'PartnerPerson '(caption "В лице")))
    (visual
     (Name
      (numerator 1)
      (caption "Договор №")
      (style Mini))
     (Date
      (caption "от"))
     (Sum
      (caption "Сумма"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Сторона 1")
     ,(ctrl-firm 'Partner $doc 'duties-std "Сторона 2")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h (v (h Name Date)
                     Firm
                     FirmPerson
                     FirmBase
                     Subject)
                  (v Note 
                     Partner
                     PartnerPerson
                     PartnerBase
                     (h Sum NDS CurrCtl)))
               ))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Name Firm FirmBase FirmPerson Subject] [Note Partner PartnerBase PartnerPerson Sum]))
    (styles ([Mini Precision Sum] [Micro2 NDS]))
    )))

(define arch-contract (arch-form "Архив договоров" 'doc-contract #f #t))
