(define export '(export
                 (forms doc-cover
                        arch-cover)))

(define ds-cover
  (quasiquote
   (dataset
    (fields (Doc Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num)))))

(define-doc doc-cover
  (quasiquote
   (form
    (caption "Конверт")
    (dataset ds-cover)
    (archive arch-cover)
    (controls
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'FirmPerson '(caption "Сотрудник"))
     ,(ctrl-people 'Partner $doc 'PartnerPerson '(caption "Сотрудник")))
    (visual
     ,(ctrl-firm 'Firm $doc 'duties-std "От кого")
     ,(ctrl-firm 'Partner $doc 'duties-std "Кому"))
    (layout (v (h (v Firm
                     FirmPerson)
                  (v Partner
                     PartnerPerson))))
    (groups ([Firm FirmPerson] [Partner PartnerPerson])))))

(define arch-cover (arch-form "Архив конвертов" 'doc-cover #f #f))
