(define export '(export
                 (forms doc-credit-order
                        arch-credit-order)))

(define ds-credit-order
  (quasiquote
   (dataset
    (extend
     (SubCode
      (mode extend)
      (index 0)
      (type LongString))
     (AltDep
      (mode extend)
      (index 1)
      (type LongString))
     (AnAccnt
      (mode extend)
      (index 2)
      (type LongString))
     (Debit
      (mode extend)
      (index 3)
      (type LongString))
     (DestCode
      (mode extend)
      (index 4)
      (type LongString))
     (Basis
      (mode extend)
      (index 5)
      (type LongString)
      (caption "Основание")
      (tags template))
     (Applet
      (mode extend)
      (index 6)
      (type LongString)
      (caption "Приложение")
      (tags template))
     (TaxPart
      (mode extend)
      (index 7)
      (type LongString)
      (caption "В том числе"))
     (NDS
      (mode extend)
      (index 8)
      (type Percent)
      (caption "Ставка НДС (%)")))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 SubCode AltDep AnAccnt Debit DestCode Basis Applet TaxPart NDS)))))

(define-doc doc-credit-order
  (quasiquote
   (form
    (caption "Приходный ордер")
    (dataset ds-credit-order)
    (archive arch-credit-order)
    (fill
     (caption "приходному ордеру")
     (require Std)
     (provide Payment))
    (controls
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     (NSR
      (type Relay)
      (method "nds-string-co")
      (bind ([Sum Master Sum]
             [NDS Master NDS]
             [Str Master TaxPart])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Partner $doc 'Person '(caption "Через кого")))
    (visual
     (Name
      (numerator 1)
      (caption "Приходный ордер №")
      (style Mini))
     (Date
      (caption "от"))
     (Sum
      (caption "Сумма"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Организация")
     ,(ctrl-firm 'Partner $doc 'duties-std "Принято от")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Name Date)
               (h (v "<>Дебет\n " Debit) "|"
                  (v "<>Код структурного\nподразделения" SubCode) "|"
                  (v "<>Корреспонди-\nрующий счет" AltDep) "|"
                  (v "<>Код аналитичес-\nкого учета" AnAccnt) "|"
                  (v "<>Код целевого\nназначения" DestCode))
               Firm Partner Person Basis
               Sum
               NDS TaxPart Applet))
    (groups ([Firm Name Partner Sum Basis Applet TaxPart Person NDS]))
    (styles ([Mini Precision SubCode AltDep AnAccnt Debit DestCode Sum NDS])))))

(define ds-credit-order-arch-docs
  (quasiquote
   (dataset
    (extend
     (PayState
      (mode raw)
      (type ImageName)
      (caption "PayState")
      (raw "(SELECT \"oState\" FROM \"pDocGetPaymentState\"(r_Doc.\"fObject\"))"))
     (PaySum
      (mode raw)
      (type Money)
      (caption "PaySum")
      (raw "(SELECT SUM(\"fSum\") FROM \"tPayment\" WHERE \"fDoc\" = r_Doc.\"fObject\")"))
     (PersonFIO
      (mode raw)
      (type ExtString)
      (caption "Через кого")
      (raw ,(mix "coalesce("
                 "  (select first 1" br
                 "    p.\"fSecondName\" ||" br
                 "      coalesce((' ' || nullif(substring(p.\"fFirstName\" from 1 for 1), '') || '.'), '') ||" br
                 "      coalesce((' ' || nullif(substring(p.\"fLastName\" from 1 for 1), '') || '.'), '')" br
                 "   from" br
                 "    \"tMutualRef\" r_Person" br
                 "   join" br
                 "    \"tPeople\" p on (p.\"fObject\" = r_Person.\"fValue\")" br
                 "   where" br
                 "    (r_Person.\"fOwner0\" = r_Doc.\"fObject\") and" br
                 "    (r_Person.\"fOwner1\" = r_Doc.\"fPartner\") and" br
                 "    (r_Person.\"fName\" = 'Person.doc-credit-order'))" br
                 "," br
                 "  (select first 1" br
                 "    p.\"fSecondName\" ||" br
                 "      coalesce((' ' || nullif(substring(p.\"fFirstName\" from 1 for 1), '') || '.'), '') ||" br
                 "      coalesce((' ' || nullif(substring(p.\"fLastName\" from 1 for 1), '') || '.'), '')" br
                 "   from" br
                 "    \"tMutualRef\" r_Person" br
                 "   join" br
                 "    \"tPeople\" p on (p.\"fObject\" = r_Person.\"fValue\")" br
                 "   where" br
                 "    (r_Person.\"fOwner0\" = '070000000001') and" br
                 "    (r_Person.\"fOwner1\" = r_Doc.\"fPartner\") and" br
                 "    (r_Person.\"fName\" = 'Person.doc-credit-order'))" br
                 ")" br
                 )))
     )
    (fields (Doc Type (Firm ShortName) (Partner ShortName) Date Name Num Sum PaySum PayState PersonFIO Mark))
    (where (Type = "'doc-credit-order'")
           [nnvl Firm = :aFirm]
           [nnvl Partner = :aPartner]
           [nnvl Date >= :aFrom]
           [nnvl Date <= :aTo]
           [nnvl :aPayState CONTAINING PayState]))))

(define arch-credit-order (arch-form "Архив приходных ордеров" 'doc-credit-order #f #f
                                     '(ds-docs ds-credit-order-arch-docs)
                                     '(column-person-fio #t)))
