(define export '(export
                 (forms doc-expense-report
                        arch-expense-report)))

(define ds-expense-report
  (quasiquote
   (dataset
    (extend
     (SubFirm
      (mode extend)
      (index 0)
      (type LongString)
      (caption "Стр. подразделение")
      (tags template))
     (SubCode
      (mode extend)
      (index 1)
      (type LongString)
      (caption "Код"))
     (AdvDest
      (mode extend)
      (index 2)
      (type LongString)
      (caption "Назначение аванса")
      (tags template))
     (OrderName
      (mode extend)
      (index 3)
      (type LongString)
      (caption "По кассовому ордеру №"))
     (OrderDate
      (mode extend)
      (index 4)
      (type Date)
      (caption "от"))
     (AppDocs
      (mode extend)
      (index 5)
      (type LongString))
     (AppPages
      (mode extend)
      (index 6)
      (type LongString))
     (PrevP
      (mode extend)
      (index 7)
      (type Money)
      (caption "Остаток"))
     (PrevN
      (mode extend)
      (index 8)
      (type Money)
      (caption "Перерасход"))
     (GiveN1
      (mode extend)
      (index 9)
      (type Money)
      (caption "Аванс 1"))
     (GiveN2
      (mode extend)
      (index 10)
      (type Money)
      (caption "Аванс 2")))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num 
                 SubFirm SubCode AdvDest OrderName OrderDate AppDocs AppPages PrevP PrevN GiveN1 GiveN2 Sum)))))

(define-doc doc-expense-report
  (quasiquote
   (form
    (caption "Авансовый отчет")
    (dataset ds-expense-report)
    (archive arch-expense-report)
    (controls
     (Expense
      (type Grid)
      (dataset ds-expense-std)
      (bind ([aDoc Master Object]
             [Precision Master Precision]
             [AggSumRN Master Sum]))
      (form form-expense-std)
      (columns ([Date "Дата"]
                [Number "Номер"]
                [Name "Наименование"]
                [SumVN "По отчету руб."]
                [SumRN "К учету руб."]
                [DinV "Дебет счета"]
                [CinV "Кредит счета"])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,(ctrl-people 'Firm $doc 'Person '(caption "Подотчетное лицо")))
    (visual
     (Name
      (numerator 1)
      (caption "№")
      (style Mini))
     (Date
      (caption "от"))
     ,(ctrl-firm 'Firm $doc 'duties-std-b "Организация"))
    (layout (v (h (v (h Name Date)
                     (h PrevP GiveN1)
                     (h PrevN GiveN2)
                     (h ">Приложение" AppDocs "документов")
                     (h ">на" AppPages "листах"))
                  (v Firm
                     Person
                     (h SubFirm SubCode)
                     AdvDest
                     (h OrderName OrderDate)))
               Expense
               ))
    (childs
     (setup "Настройка" (v Precision)))
    (groups ([Firm Person SubFirm OrderName AdvDest] [Name PrevP PrevN ">Приложение" ">на"] [Date GiveN1 GiveN2] [SubCode OrderDate]))
    (styles ([Mini Precision PrevP PrevN GiveN1 GiveN2 SubFirm SubCode OrderName AppDocs AppPages])))))

(define arch-expense-report (arch-form "Архив авансовых отчетов" 'doc-expense-report #f #f '(hide-partner #t)))
