(define export '(export
                 (forms doc-invoice
                        arch-invoice)))

(define ds-invoice
  (quasiquote
   (dataset
    (extend
     (Note
      (mode extend)
      (index 0)
      (type ExtString)
      (caption "Примечание")
      (tags template)))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Note Sum)))))

(define-doc doc-invoice
  (quasiquote
   (form
    (caption "Счет")
    (dataset ds-invoice)
    (extend DocPriceFill)
    (archive arch-invoice)
    (fill
     (caption "счету")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [NDSE "НДС"]
                [Sum "Сумма"]
                [ModelGroupName "Группа"]))
      )
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner)
    (visual
     (Name
      (numerator 1)
      (caption "Счет №")
      (style Mini))
     (Date
      (caption "от"))
     (Note
      (type String)
      (caption "Примечание"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Продавец")
     ,(ctrl-firm 'Partner $doc 'duties-std "Покупатель")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Firm Partner)
               (h Name Date Note CurrCtl)
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Firm Name] [Partner Note]))
    (styles ([Mini Precision])))))

(define arch-invoice (arch-form "Архив счетов" 'doc-invoice #t #t))
