(define export '(export
                 (forms doc-pay-request
                        arch-pay-request)))

(define ds-pay-request
  (quasiquote
   (dataset
    (extend
     (PayType
      (mode extend)
      (index 0)
      (type ShortString)
      (caption "Вид платежа"))
     (AcceptDays
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Срок для акцепта"))
     (PayKind
      (mode extend)
      (index 2)
      (type ShortString))
     (SendDate
      (mode extend)
      (index 3)
      (type Date))
     (PayOrd
      (mode extend)
      (index 4)
      (type ShortString))
     (PayCode
      (mode extend)
      (index 5)
      (type ShortString))
     (Purpose
      (mode extend)
      (index 6)
      (type MemoString))
     (NDS
      (mode extend)
      (index 7)
      (type Percent)
      (caption "НДС"))
     (No2ndSign
      (mode extend)
      (index 8)
      (type LongString))
     (NoNDS
      (mode extend)
      (index 9)
      (type LongString))
     (NDSStr
      (mode extend)
      (index 10)
      (type LongString))
     (PayCond
      (mode extend)
      (index 11)
      (type MemoString))
     )
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 PayKind PayType AcceptDays SendDate PayOrd PayCode
                 Purpose NDS No2ndSign NoNDS NDSStr PayCond)))))

(define-doc doc-pay-request
  (quasiquote
   (form
    (caption "Платежное требование")
    (dataset ds-pay-request)
    (archive arch-pay-request)
    (controls
     ;(CurrCtl
     ; (type Curr)
     ; (bind ([Doc Master Object]
     ;        [Curr Master Curr]
     ;        [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     (NSR
      (type Relay)
      (method "nds-string-po")
      (bind ([Sum Master Sum]
             [NDS Master NDS]
             [Str Master NDSStr])))
     ,mutual-firm
     ,mutual-partner)
    (visual
     (Name
      (numerator 1))
     (Date
      (caption "Дата"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Плательщик")
     ,(ctrl-firm 'Partner $doc 'duties-std "Получатель")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."])))
     (PayType
      (values (["Почтой"]
               ["Телеграфом"]
               ["Электронный"]
               ["Срочный"]
               ["По договору"]
               ["Клиринг"])))
     )
    (layout (v (h (v (h "Платежное требование №" Name Date)
                     (h "Условие\nоплаты" "|" PayCond)) 
                  (v PayType AcceptDays))
               "--"
               (h (v (h (v Firm
                           "ИНН [Master.Firm.INN]/КПП [Master.Firm.KPP]"
                           "[Master.Firm.FullName]"
                           "--"
                           "Банк плательщика" "[Master.Firm.Bank]"
                           "--")
                        (v (h "|" "<<210>>")
                           (h "|" "--")
                           (h "|" "Сч. №" "[Master.Firm.RasDep]") "--"
                           (h "|" "БИК" "[Master.Firm.BIK]")
                           (h "|" "Сч. №" "[Master.Firm.CorDep]") "--"))
                     (h (v Partner
                           "ИНН [Master.Partner.INN]/КПП [Master.Partner.KPP]"
                           "[Master.Partner.FullName]"
                           "--"
                           "Банк получателя" "[Master.Partner.Bank]"
                           )
                        (v "|" (h "|" "--")
                           (h "|" "Сч. №" "[Master.Partner.RasDep]") "--"
                           (h "|" "БИК" "[Master.Partner.BIK]")
                           (h "|" "Сч. №" "[Master.Partner.CorDep]"))))
                  "|"
                  (v "Сумма"
                     Sum
                     "Вид оп."
                     PayKind
                     "Очер. плат."
                     PayOrd
                     "Код"
                     PayCode
                     "Дата отсылки"
                     SendDate
                     )) "--"
               "Назначение платежа"
               Purpose
               (h NDS "%" NDSStr)
               ;(h CurrCtl)
               ))
    (childs
     (setup "Настройка" (v "Формат указателя отсутствия второй подписи:" No2ndSign "Формат указателя отсутствия НДС:" NoNDS)))
    (styles ([Mini Name PayType Sum PayKind PayOrd PayCode NDS AcceptDays]))
    (groups ([Firm Partner] ["БИК" "Сч. №"] ["Условие\nоплаты" "Сумма\nпрописью"]))
    )))

(define arch-pay-request (arch-form "Архив платежных требований" 'doc-pay-request #f #f))
