(define export '(export
                 (forms doc-pd4
                        arch-pd4)))

(define ds-pd4
  (quasiquote
   (dataset
    (extend
     (DocIndex
      (mode extend)
      (index 0)
      (caption "Индекс документа")
      (type ShortString)
      (tags template))
     (Status
      (mode extend)
      (index 1)
      (caption "Статус")
      (type ShortString)
      (tags template))
     (PClass
      (mode extend)
      (index 2)
      (caption "КБК")
      (type ShortString)
      (tags template))
     (POKAT
      (mode extend)
      (index 3)
      (caption "ОКАТО")
      (type ShortString)
      (tags template))
     (PBase
      (mode extend)
      (index 4)
      (caption "Основание платежа")
      (type Extention)
      (tags template))
     (PPeriod
      (mode extend)
      (index 5)
      (caption "Налоговый период")
      (type LongString)
      (tags template))
     (PKind
      (mode extend)
      (index 6)
      (caption "Тип платежа")
      (type LongString)
      (tags template))
     (Forfeit
      (mode extend)
      (index 7)
      (caption "Штраф")
      (type Money))
     (Fine
      (mode extend)
      (index 8)
      (type Money))
     (FineValue
      (mode extend)
      (index 9)
      (type Money))
     (PaySum
      (mode extend)
      (index 10)
      (type Money))
     (PClass2
      (mode extend)
      (index 11)
      (caption "КБК")
      (type KBK))
     )
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 DocIndex Status PClass POKAT PBase PPeriod PKind Forfeit Fine FineValue PaySum
                 PClass2)))))

(define-doc doc-pd4
  (quasiquote
   (form
    (caption "Форма СБ РФ ПД-4")
    (dataset ds-pd4)
    (archive arch-pd4)
    (controls
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     (FineRelay
      (type Relay)
      (method "pd4-fine")
      (bind ([PaySum Master PaySum]
             [Fine Master Fine]
             [FineValue Master FineValue]
             [Forfeit Master Forfeit]
             [Sum Master Sum])))
     ,mutual-firm
     ,mutual-partner)
    (visual
     (Name
      (numerator 1))
     (Date
      (caption "Дата"))
     ,(ctrl-firm 'Firm $doc 'duties-std "<Плательщик")
     ,(ctrl-firm 'Partner $doc 'duties-std "<Получатель")
     (PClass2
      (dataset ds-kbk-inf)
      (bind (auto-name [aTypeKBK Const "pd4"]))
      (form form-kbk-std))
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."])))
     )
    (layout (v (h DocIndex Status Date)
               "--"
               (h (v (h (v Firm
                           "ИНН [Master.Firm.INN]")
                        (v (h "|" (v "Адрес [Master.Firm.Address]" "--"))
                           (h "|" (v "Сумма платежа" 
                                     (h "Пеня (%)" Fine))
                              (v PaySum FineValue)
                              (v Forfeit (h ">Итого" Sum))) 
                           )) "--"
                              (h (v "Банк получателя" "[Master.Partner.Bank]"
                                    Partner
                                    "ИНН [Master.Partner.INN]")
                                 (v (h "|" "БИК" "[Master.Partner.BIK]")
                                    (h "|" "Р/сч." "[Master.Partner.RasDep]")
                                    (h "|" "К/сч." "[Master.Partner.CorDep]")
                                    (h "|" "КПП" "[Master.Partner.KPP]"))))
                  ;"|"
                  ) "--"
                    (h (v ;(h PClass)
                          (h PClass2)
                          (h POKAT)
                          (h PPeriod))
                       (v (h PBase)
                          (h PKind))
                       ) "--"
                         ))
    ;(childs
    ; (setup "Настройка" (v "Формат указателя отсутствия второй подписи:" No2ndSign "Формат указателя отсутствия НДС:" NoNDS)))
    (styles ([Mini Name Sum Sum Forfeit FineValue PaySum DocIndex Status] [Micro Fine]))
    (groups ([DocIndex Firm Partner PClass2 POKAT PPeriod] [PBase PKind] [Forfeit PaySum ">Итого"]))
    )))

(define ds-pd4-arch-docs
  (quasiquote
   (dataset
    (extend
     (PayState
      (mode raw)
      (type ImageName)
      (caption "PayState")
      (raw "(SELECT \"oState\" FROM \"pDocGetPaymentState\"(r_Doc.\"fObject\"))"))
     (PaySum
      (mode raw)
      (type Money)
      (caption "PaySum")
      (raw "(SELECT SUM(\"fSum\") FROM \"tPayment\" WHERE \"fDoc\" = r_Doc.\"fObject\")"))
     (PBase
      (mode extend)
      (index 4)
      (type Extention)))
    (fields (Doc Type (Firm ShortName) (Partner ShortName) Date Name Num Sum PaySum PayState Mark PBase))
    (where (Type = "'doc-pd4'")
           [nnvl Firm = :aFirm]
           [nnvl Partner = :aPartner]
           [nnvl Date >= :aFrom]
           [nnvl Date <= :aTo]
           [nnvl :aPayState CONTAINING PayState]))))

(define arch-pd4 (arch-form "Архив извещений" 'doc-pd4 #f #f '(ds-docs ds-pd4-arch-docs) '(column-docs-pbase #t)))
