(define export '(export
                 (forms doc-price-ticket
                        arch-price-ticket)))

(define ds-price-ticket
  (quasiquote
   (dataset
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner Date Name Num Sum)))))

(define-doc doc-price-ticket
  (quasiquote
   (form
    (caption "Ценники")
    (dataset ds-price-ticket)
    (archive arch-price-ticket)
    (extend DocPriceFill)
    (fill
     (caption "ценникам")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [ModelGroupName "Группа" 100])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm)
    (visual
     (Name
      (numerator 1)
      (caption "Название"))
     (Date
      (caption "Дата"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Организация")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v Firm
               (h Name Date CurrCtl)
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Firm Name]))
    (styles ([Mini Precision])))))

(define arch-price-ticket (arch-form "Архив ценников" 'doc-price-ticket #t #f '(hide-partner #t)))
