(define export '(export
                 (forms doc-procuration-car
                        arch-procuration-car)))

(define ds-procuration-car
  (quasiquote
   (dataset
    (extend
     (City
      (mode extend)
      (index 0)
      (type LongString)
      (caption "Город")
      (tags template))
     (DateEnd
      (mode extend)
      (index 1)
      (type Date)
      (caption "Действительна до"))
     (Car
      (mode extend)
      (index 2)
      (type Car)
      (caption "Автомобиль")))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 City DateEnd Car)))))

(define-doc doc-procuration-car
  (quasiquote
   (form
    (caption "Доверенность на автомобиль")
    (dataset ds-procuration-car)
    (archive arch-procuration-car)
    (controls
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'FirmPerson '(caption "Доверитель") '(driver #t))
     ,(ctrl-people 'Partner $doc 'PartnerPerson '(caption "Доверенное лицо"))
     (CarNotifier
      (type ObjectNotifier)
      (bind ([Object "MutualFirm" "FirmPerson.doc-procuration-car"]
             [Car Master Car]))))
    (visual
     (Name
      (numerator 1)
      (caption "Доверенность №")
      (style Mini))
     (Date
      (caption "от"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Организация доверителя")
     ,(ctrl-firm 'Partner $doc 'duties-std "Организация доверенного лица")
     (Car
      (dataset ds-car-min)
      (bind [auto-name (aFirm Master Firm)
                       (aType Const "car")])
      (form form-car-std)))
    (layout (v (h Name Date) City Firm FirmPerson Partner PartnerPerson Car DateEnd))
    (groups ([Name City Firm FirmPerson Partner PartnerPerson Car DateEnd]))
    )))

(define arch-procuration-car (arch-form "Архив доверенностей на автомобиль" 'doc-procuration-car #f #f))
