(define export '(export
                 (forms doc-procuration
                        arch-procuration)))

(define ds-procuration
  (quasiquote
   (dataset
    (extend
     (ValidDate
      (mode extend)
      (index 0)
      (type Date)
      (caption "Действительна по"))
     (Note
      (mode extend)
      (index 2)
      (type LongString)
      (caption "Примечание")
      (tags template))
     )
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 Note ValidDate)))))

(define-doc doc-procuration
  (quasiquote
   (form
    (caption "Доверенность")
    (dataset ds-procuration)
    (archive arch-procuration)
    (fill
     (caption "доверенности")
     (require Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [ModelGroupName "Группа" 100])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Firm $doc 'Person))
    (visual
     (Name
      (numerator 1)
      (caption "Доверенность №")
      (style Mini))
     (Date
      (caption "от"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Организация")
     ,(ctrl-firm 'Partner $doc 'duties-std "На получение от")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Firm Partner)
               (h Name Date Note)
               (h ">Выдана" Person ValidDate)
               Goods
               ))
    (childs
     (setup "Настройка" (v Precision SumMethod)))
    (groups ([Firm Name ">Выдана"] [Partner Note ValidDate]))
    (styles ([Mini BaseNum Precision]))
    )))

(define arch-procuration (arch-form "Архив доверенностей" 'doc-procuration #t #f))
