(define export '(export
                 (forms doc-receive-request
                        arch-receive-request)))

(define ds-receive-request
  (quasiquote
   (dataset
    (extend
     (DateIsp
      (mode extend)
      (index 0)
      (type Date)
      (caption "Предельная дата исполнения"))
     (NumBO
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Номер обязательства")))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum DateIsp NumBO)))))

(define-doc doc-receive-request
  (quasiquote
   (form
    (caption "Заявка на получение наличных денег")
    (dataset ds-receive-request)
    (archive arch-receive-request)
    (controls
     (SubDocR
      (type Grid)
      (dataset ds-subdocr-std)
      (bind ([aDoc Master Object]
             [Precision Master Precision]
             ;[Curr CurrCtl Curr]
             ;[ByCurr CurrCtl ByCurr]
             ;[Rate CurrCtl Rate]
             [AggSumR Master Sum]))
      (form form-subdocr-std)
      (columns ([SumR "Сумма в рублях" 100]
                [CheckNum "Номер чека" 100]
                [CheckSer "Серия чека" 100]
                [CheckDate "Дата чека" 100]
                [CheckDateLim "Срок действия чека" 150]
                [CheckKas "Символ кассового плана" 150])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,(ctrl-people 'Firm $doc 'Person))
    (visual
     (Name
      (numerator 1)
      (caption "Заявка №")
      (style Mini))
     (Date
      (caption "от"))
     ,(ctrl-firm 'Firm $doc 'duties-std "Наименование клиента"))
    (layout (v (h Name Date Firm) 
               (h NumBO ">Доверенное лицо" Person)
               (h DateIsp CurrCtl)
               SubDocR
               (h "Сумма [SubDocR.AggSumR/float/Master.Precision]")))
    (childs
     (setup "Настройка" (v Precision)))
    (groups ([Name NumBO DateIsp] [Firm ">Доверенное лицо"]))
    (styles ([Mini Precision])))))

(define arch-receive-request (arch-form "Архив заявок на получение наличных денег" 'doc-receive-request #f #f '(export receive-request) '(hide-partner #t)))

(define form-subdocr-std
  (quasiquote
   (form
    (caption "Реквизиты чека")
    (dataset ds-subdocr)
    (controls
     (SubSubDocR
      (type Grid)
      (dataset ds-subsubdocr-std)
      (bind ([aSubDocR Master Object]
             [Precision Caller Precision]))
      (form form-subsubdocr-std)
      (columns ([CodeIst "Источник средств" 100]
                [KBKName "Код по КБК" 100]
                [TypeKBK "Тип КБК" 100]
                [AddKlass "Код цели" 100]
                [SumRKBK "Сумма" 100]
                [Purpose "Назначение платежа" 100]
                [Note "Примечание" 100]))
      ))
    (layout (v (h (v CheckNum CheckSer SumR)
                  (v CheckDate CheckDateLim CheckKas)) 
               SubSubDocR))
    (groups ([CheckNum CheckSer SumR] [CheckKas CheckDate CheckDateLim]))
    (styles ([Mini SumR CheckKas])))))

(define form-subsubdocr-std
  (quasiquote
   (form
    (caption "Расшифровка заявки на получение наличных денег")
    (dataset ds-subsubdocr)
    (visual
     (KBK
      (dataset ds-kbk-min)
      (bind [auto-name (aTypeKBK Const "receive-request")])
      (form form-kbk-std))
     (CodeIst
      (type Combo)
      (mode string)
      (values (["1" "средства бюджета"]
               ["2" "средства от приносящей доход деятельности"]
               ["3" "средства дополнительного бюджетного финансирования"]
               ["4" "средства для финансирования мероприятий по оперативно-розыскной деятельности"]
               ["5" "средства, поступающие во временное распоряжение бюджетных учреждений"]))))
    (layout (v CodeIst KBK TypeKBK AddKlass SumRKBK Purpose Note))
    (styles ([Mini SumRKBK])))))

(define ds-subsubdocr-std
  (quasiquote
   (dataset
    (fields (SubSubDocR SubDocR CodeIst (KBK Name) TypeKBK AddKlass SumRKBK Purpose Note OrderA))
    (where (SubDocR = :aSubDocR)))))

(define ds-subsubdocr
  (quasiquote
   (dataset
    (fields (SubSubDocR SubDocR CodeIst KBK TypeKBK AddKlass SumRKBK Purpose Note OrderA)))))

(define ds-subdocr-std
  (quasiquote
   (dataset
    (fields (SubDocR Doc SumR CheckNum CheckSer CheckDate CheckDateLim CheckKas 
                     CodeIst KBK TypeKBK AddKlass SumRKBK Purpose Note OrderA))
    (aggregates
     (AggSumR SumR Sum))
    (where (Doc = :aDoc)))))

(define ds-subdocr
  (quasiquote
   (dataset
    (fields (SubDocR Doc SumR CheckNum CheckSer CheckDate CheckDateLim CheckKas 
                     CodeIst KBK TypeKBK AddKlass SumRKBK Purpose Note OrderA)))))
