(define export '(export
                 (forms doc-waybill
                        arch-waybill)))

(define ds-waybill
  (quasiquote
   (dataset
    (extend
     (Note
      (mode extend)
      (index 0)
      (type LongString)
      (caption "Накладная"))
     (Base
      (mode extend)
      (index 2)
      (type LongString)
      (caption "Основание")
      (tags template))
     (BaseNum
      (mode extend)
      (index 3)
      (type LongString)
      (caption "По доверенности №"))
     (BaseDate
      (mode extend)
      (index 4)
      (type Date)
      (caption "от"))
     (Car
      (mode extend)
      (index 5)
      (type Car)
      (caption "Автомобиль"))
     (DeliveryDate
      (mode extend)
      (index 6)
      (type Date)
      (caption "Срок доставки груза"))
     (TransType
      (mode extend)
      (index 7)
      (type LongString)
      (caption "Вид перевозки"))
     (PointLoading
      (mode extend)
      (index 8)
      (type LongString)
      (caption "Пункт погрузки"))
     (PointUnloading
      (mode extend)
      (index 9)
      (type LongString)
      (caption "Пункт разгрузки"))
     (Redirect
      (mode extend)
      (index 10)
      (type LongString)
      (caption "Переадресовка"))
     (Organization
      (mode extend)
      (index 11)
      (type Firm)
      (caption "Организация"))
     (Payer
      (mode extend)
      (index 12)
      (type Firm)
      (caption "Плательщик")))
    (fields (Doc SumMethod Precision Type Curr ByCurr Firm FirmCargo Partner PartnerCargo Date Name Num Sum
                 Note Base BaseNum BaseDate Car DeliveryDate TransType PointLoading PointUnloading Redirect
                 Organization Payer)))))

(define-doc doc-waybill
  (quasiquote
   (form
    (caption "Накладная")
    (dataset ds-waybill)
    (archive arch-waybill)
    (extend DocPriceFill)
    (fill
     (caption "накладной")
     (require Std Goods)
     (provide Std Goods))
    (controls
     (Goods
      (type Grid)
      (dataset ds-goods-std)
      (bind ([AggSum1 Master Sum]
             [aDoc Master Object]
             [Precision Master Precision]
             [SumMethod Master SumMethod]
             [Curr CurrCtl Curr]
             [ByCurr CurrCtl ByCurr]
             [Rate CurrCtl Rate]
             [Notify.Firm Master Firm]))
      (form form-goods-std)
      (columns ([MModelName "Наименование" 200 rw]
                [VolumeName "Ед. изм." 100]
                [Count "Количество" 80 rw]
                [PriceF "Цена без НДС" -85]
                [PriceT "Цена"]
                [NDSE "НДС"]
                [Sum "Сумма"]
                [ModelGroupName "Группа" 100])))
     (CurrCtl
      (type Curr)
      (bind ([Doc Master Object]
             [Curr Master Curr]
             [ByCurr Master ByCurr])))
     (Numerator
      (type Numerator)
      (bind ([Name Master Name]
             [Num Master Num])))
     ,mutual-firm
     ,mutual-partner
     ,(ctrl-people 'Partner $doc 'Person '(caption "Через кого"))
     (TransPart
      (type CmdButton)
      (text "Транспортная часть")
      (cmd Child trans))
     ;,(ctrl-people 'Organization $doc 'Driver '(caption "Водитель") '(driver #t))
     (Driver
      (type Reference)
      (caption "Водитель")
      (dataset ds-people-min)
      (form (form-people-firm 'Organization ',$doc 'Driver '(driver #t)))
      (bind ([Default "MutualOrganization" ,(mix "Driver." $doc)]
             [aFirm RelayOrganization Default])))
     (MutualOrganization
      (type MutualRef)
      (bind ([Owner0 Master Object]
             [Owner1 RelayOrganization Default]
             )))
     (GoodsC
      (type Grid)
      (dataset ds-goodsc-std)
      (bind ([aDoc Master Object]))
      (form form-goodsc-std)
      (columns ([Name "Описание груза" 100]
                [Note "Документы" 100]
                [PackType "Вид упаковки"]
                [PackNum "Кол-во мест"]
                [MassMode "Способ определения массы"]
                [Code "Код груза"]
                [Container "Номер контейнера"]
                [Class "Класс груза"]
                [Mass "Масса брутто"])))
     ;,(ctrl-people 'Organization $doc 'PersonGive '(caption "Сдал"))
     ;,(ctrl-people 'Organization $doc 'PersonTake '(caption "Принял"))
     (PersonGive
      (type Reference)
      (caption "Сдал")
      (dataset ds-people-min)
      (form (form-people-firm 'Organization ',$doc 'PersonGive))
      (bind ([Default "MutualOrganization" ,(mix "PersonGive." $doc)]
             [aFirm RelayOrganization Default])))
     (PersonTake
      (type Reference)
      (caption "Принял")
      (dataset ds-people-min)
      (form (form-people-firm 'Organization ',$doc 'PersonTake))
      (bind ([Default "MutualOrganization" ,(mix "PersonTake." $doc)]
             [aFirm RelayOrganization Default])))
     (Trailer
      (type Reference)
      (dataset ds-car-min)
      (form form-car-std)
      (caption "Прицеп")
      (bind ([Default "MutualOrganization" ,(mix "Trailer." $doc)]
             [aFirm RelayOrganization Default]
             [aType Const "trailer"])))
     (CarNotifier
      (type ObjectNotifier)
      (bind ([Object "MutualOrganization" ,(mix "Driver." $doc)]
             [Car Master Car])))
     (RelayOrganization
      (type LinkRelay)
      (bind ([Source Master Organization]
             [Link0 Master Firm]
             [Link1 Master Partner])))
     )
    (visual
     (Name
      (numerator 1)
      (caption "Накладная №")
      (style Mini))
     (Date
      (caption "от"))
     (Car
      (dataset ds-car-min)
      (bind (auto-name
             [aFirm RelayOrganization Default]
             [aType Const "car"]))
      (form form-car-std))
     (Organization
      (dataset ds-partner-min)
      (static-rows ([Link0 "Отправитель"]
                    [Link1 "Получатель"]))
      (form (form-firm-doc 'Partner ',$doc duties-std)))
     (Payer
      (dataset ds-partner-min)
      (static-rows ([Link0 "Отправитель"]
                    [Link1 "Получатель"]))
      (form (form-firm-doc 'Partner ',$doc duties-std)))
     ,(ctrl-firm 'Firm $doc 'duties-std-a "Отправитель")
     ,(ctrl-firm 'Partner $doc 'duties-std "Получатель")
     (SumMethod
      (type Combo)
      (mode string)
      (values (["AA" "От суммы"]
               ["AB" "От единицы"]
               ["BA" "От суммы (банковское округление)"]
               ["BB" "От единицы (банковское округление)"]
               [<custom.calc-method> "Дополнительно..."]))))
    (layout (v (h Firm Partner TransPart)
               (h Name Date Person)
               (h Base BaseNum BaseDate CurrCtl)
               Goods
               (h "Сумма [Goods.AggSum1/float/Master.Precision], [Goods.AggSumN/float/Master.Precision/в том числе НДС /Без НДС]")
               ))
    (childs
     (setup "Настройка" (v Precision SumMethod))
     (trans "Транспортная часть" (v (h (v Organization DeliveryDate Driver Car Trailer PersonGive)
                                       (v Payer TransType PointLoading PointUnloading Redirect PersonTake))
                                    GoodsC)))
    (groups ([Firm Name Base] [Partner Person BaseNum]))
    (styles ([Mini BaseNum Precision])))))

(define arch-waybill (arch-form "Архив накладных" 'doc-waybill #t #t))
