(define export '(export
                 (forms export-1c-a.form
                        ;form-export-epd-b
                        )))

(define export-1c-a.form.ds
  (ds.table-extend
   'Custom
   (quasiquote
    ((FileName 0 LongString "Имя файла" (select-file))))))

(define export-1c-a.form
  (quasiquote
   (form
    (caption "Файл формата 1С")
    (export epd)
    (handler export-1c-a)
    (dataset export-1c-a.form.ds)
    (layout (v FileName)))))

(define (export-1c-a.require) '(FileName From To Firm Partner))

(define (export-1c-a.x) export.params)

(define (export-1c-a.ds)
  (quasiquote
   (dataset
    (extend
     (PayType
      (mode extend)
      (index 0)
      (type ShortString)
      (caption "Вид платежа"))
     (State
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Статус"))
     (PayKind
      (mode extend)
      (index 2)
      (type ShortString))
     (PayDate
      (mode extend)
      (index 3)
      (type Date))
     (PayOrd
      (mode extend)
      (index 4)
      (type ShortString))
     (PayCode
      (mode extend)
      (index 5)
      (type ShortString))
     (PClass
      (mode extend)
      (index 6)
      (type KBK))
     (POKAT
      (mode extend)
      (index 7)
      (type Okato))
     (PBase
      (mode extend)
      (index 8)
      (type ShortString))
     (PPeriod
      (mode extend)
      (index 9)
      (type ShortString))
     (PNum
      (mode extend)
      (index 10)
      (type ShortString))
     (PDocDt
      (mode extend)
      (index 11)
      (type ShortString))
     (PKind
      (mode extend)
      (index 12)
      (type ShortString))
     (Purpose
      (mode extend)
      (index 13)
      (type MemoString))
     (NDS
      (mode extend)
      (index 14)
      (type Percent)
      (caption "НДС"))
     (No2ndSign
      (mode extend)
      (index 15)
      (type LongString))
     (NoNDS
      (mode extend)
      (index 16)
      (type LongString))
     (NDSStr
      (mode extend)
      (index 17)
      (type LongString)))
    (fields (Doc Type Name Date PayType PayKind PayDate PayOrd PayCode Purpose NDSStr State
                 (PClass Name) (POKAT Name) PBase PPeriod PNum PDocDt PKind
                 (Firm FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep)
                 (Partner FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep) Sum NDS No2ndSign NoNDS)))))

(define (export-1c-a.query)
  (qu.set-part (ds.q-select (export-1c-a.ds)) 'where
               (mix "WHERE" br "  (r_Doc.\"fType\" = 'doc-pay-order')"
                    (eu.nnvl 'Firm " and (r_Doc.\"fFirm\" = '?')")
                    (eu.nnvl 'Partner " and (r_Doc.\"fPartner\" = '?')")
                    (eu.nnvl 'From " and (r_Doc.\"fDate\" >= '?')")
                    (eu.nnvl 'To " and (r_Doc.\"fDate\" <= '?')"))))

(define (export-1c-a.prepare)
  
  (define (epd-ord n)
    (string
     (if (< n 10)
         (integer->char (+ n 48))
         (integer->char (+ n 55)))))
  
  (let* ([now (seconds->date (current-seconds))]
         [day (date-day now)]
         [month (date-month now)]
         [form-file-name (ext-call 's1251 (ext-call 'form-get-variable 'FileName))]
         [ofk-dep-d (cadr (ext-call 'query-select (mix "SELECT \"fOfkDep\" FROM \"tFirm\" WHERE \"fObject\" = '" (ext-call 'form-get-variable 'Firm) "'")))]
         [ofk-dep (if (null? ofk-dep-d) "XXXXX" (subr (vector-ref (car ofk-dep-d) 0) 5 10))]
         [file-name (if (eq? (string-length form-file-name) 0) (build-path root-path "empty.ext") (string->path form-file-name))])
    
    (let-values ([(base name dir?) (split-path file-name)])
      (ext-call 'form-set-variable 'FileName (path->string (build-path base "1C_to_KL.txt"))))))

(define (export-1c-a.write)
  
  (define (date->epd date)
    (let ([s (format "~a" date)])
      (if (or (equal? s "1899-12-30") (equal? s "1899-12-30 00:00:00.0000"))
          ""
          (mix (substring s 8 10) "." (substring s 5 7) "." (substring s 0 4)))))
  
  (define (bank-city b)
    (let 
        ([city (regexp-match "Г\\..+" (string-upcase (bytes1251->string b)))]) 
      (if city (car city) "")))
  
  (define (format-int n c)
    (let* ([s (number->string n)]
           [len (string-length s)])
      (if (< len c) 
          (string-append (make-string (- c len) #\0) s)
          s)))
  
  (let ([documents (tu.table-rows-by-name (ext-call 'query-select (export-1c-a.query)))])
    (display "1CClientBankExchange") (w-br)
    (write-bytes (string->bytes1251 "ВерсияФормата=1.01")) (w-br)
    (write-bytes (string->bytes1251 "Кодировка=Windows")) (w-br)
    (write-bytes (string->bytes1251 "Отправитель=Бизнес Пак 7")) (w-br)
    (write-bytes (string->bytes1251 "Получатель=ClientBank")) (w-br)
    (write-bytes (string->bytes1251 "ДатаСоздания=")) (display (mix (format-int (date-day (seconds->date (current-seconds))) 2) "." (format-int (date-month (seconds->date (current-seconds))) 2) "." (date-year (seconds->date (current-seconds))))) (w-br)
    (write-bytes (string->bytes1251 "ВремяСоздания=")) (display (mix (format-int (date-hour (seconds->date (current-seconds))) 2) ":" (format-int (date-minute (seconds->date (current-seconds))) 2) ":" (format-int (date-second (seconds->date (current-seconds))) 2))) (w-br)
    (write-bytes (string->bytes1251 "ДатаНачала=")) (display (date->epd (ext-call 'form-get-variable 'From))) (w-br)
    (write-bytes (string->bytes1251 "ДатаКонца=")) (display (date->epd (ext-call 'form-get-variable 'To))) (w-br)
    (write-bytes (string->bytes1251 "РасчСчет=")) (display (vector-ref (car (cadr (ext-call 'query-select (mix "SELECT \"fRasDep\" FROM \"tFirm\" WHERE \"fObject\" = '" (ext-call 'form-get-variable 'Firm) "'")))) 0)) (w-br)
    (write-bytes (string->bytes1251 "Документ=Платежное поручение")) (w-br)
    (map (lambda (row)
           (let ([class-codes (tu.table-rows-by-name (ext-call 'query-select (mix "SELECT * FROM \"tClassCode\" WHERE \"fDoc\" = '" (row 'Object) "'")))])
             (write-bytes (string->bytes1251 "СекцияДокумент=Платежное поручение")) (w-br)
             (write-bytes (string->bytes1251 "Номер=")) (write-bytes (row 'Name)) (w-br)
             (write-bytes (string->bytes1251 "Дата=")) (display (date->epd (row 'Date))) (w-br)
             (write-bytes (string->bytes1251 "Сумма=")) (display (double->str2 (row 'Sum))) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикСчет=")) (write-bytes (subr (row 'FirmRasDep) 0 50)) (w-br)
             (write-bytes (string->bytes1251 "Плательщик=")) (write-bytes (row 'FirmFullName)) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикИНН=")) (write-bytes (subr (row 'FirmINN) 0 12)) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикКПП=")) (write-bytes (subr (row 'FirmKPP) 0 9)) (w-br)
             (write-bytes (string->bytes1251 "Плательщик1=")) (write-bytes (row 'FirmFullName)) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикРасчСчет=")) (write-bytes (subr (row 'FirmRasDep) 0 50)) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикБанк1=")) (write-bytes (row 'FirmBank)) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикБанк2=")) (write-bytes (string->bytes1251 (bank-city (row 'FirmBank)))) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикБИК=")) (write-bytes (subr (row 'FirmBIK) 0 9)) (w-br)
             (write-bytes (string->bytes1251 "ПлательщикКорсчет=")) (write-bytes (subr (row 'FirmCorDep) 0 50)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательСчет=")) (write-bytes (subr (row 'PartnerRasDep) 0 50)) (w-br)
             (write-bytes (string->bytes1251 "Получатель=")) (write-bytes (row 'PartnerFullName)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательИНН=")) (write-bytes (subr (row 'PartnerINN) 0 12)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательКПП=")) (write-bytes (subr (row 'PartnerKPP) 0 9)) (w-br)
             (write-bytes (string->bytes1251 "Получатель1=")) (write-bytes (row 'PartnerFullName)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательРасчСчет=")) (write-bytes (subr (row 'PartnerRasDep) 0 50)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательБанк1=")) (write-bytes (row 'PartnerBank)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательБанк2=")) (write-bytes (string->bytes1251 (bank-city (row 'PartnerBank)))) (w-br)
             (write-bytes (string->bytes1251 "ПолучательБИК=")) (write-bytes (subr (row 'PartnerBIK) 0 9)) (w-br)
             (write-bytes (string->bytes1251 "ПолучательКорсчет=")) (write-bytes (subr (row 'PartnerCorDep) 0 50)) (w-br)
             (write-bytes (string->bytes1251 "ВидПлатежа=")) (write-bytes (row 'PayType)) (w-br)
             (write-bytes (string->bytes1251 "ВидОплаты=")) (write-bytes (subr (row 'PayKind) 0 2)) (w-br)
             (write-bytes (string->bytes1251 "СтатусСоставителя=")) (write-bytes (subr (row 'State) 0 2)) (w-br)
             (write-bytes (string->bytes1251 "ПоказательКБК=")) (write-bytes (subr (row 'PClassName) 0 20)) (w-br)
             (write-bytes (string->bytes1251 "ОКАТО=")) (write-bytes (subr (row 'POKATName) 0 11)) (w-br)
             (write-bytes (string->bytes1251 "ПоказательОснования=")) (write-bytes (subr (row 'PBase) 0 2)) (w-br)
             (write-bytes (string->bytes1251 "ПоказательПериода=")) (write-bytes (subr (row 'PPeriod) 0 10)) (w-br)
             (write-bytes (string->bytes1251 "ПоказательНомера=")) (write-bytes (row 'PNum)) (w-br)
             (write-bytes (string->bytes1251 "ПоказательДаты=")) (write-bytes (row 'PDocDt)) (w-br) ;(display (date->epd (row 'PDocDt))) (w-br)
             (write-bytes (string->bytes1251 "ПоказательТипа=")) (write-bytes (subr (row 'PKind) 0 2)) (w-br)
             (write-bytes (string->bytes1251 "СрокПлатежа=")) (display (date->epd (row 'PayDate))) (w-br)
             (write-bytes (string->bytes1251 "Очередность=")) (write-bytes (subr (row 'PayOrd) 0 2)) (w-br)
             (write-bytes (string->bytes1251 "НазначениеПлатежа=")) (write-bytes (bytes-append (list->bytes (map (lambda (b) (if (< b 32) 0 b)) (bytes->list (row 'Purpose)))) (if (> (bytes-length (row 'Purpose)) 0) #" " #"") (row 'NDSStr))) (w-br)
             (write-bytes (string->bytes1251 "НазначениеПлатежа1=")) (write-bytes (bytes-append (list->bytes (map (lambda (b) (if (< b 32) 0 b)) (bytes->list (row 'Purpose)))))) (w-br)
             (write-bytes (string->bytes1251 "НазначениеПлатежа2=")) (write-bytes (bytes-append (row 'NDSStr))) (w-br)
             (write-bytes (string->bytes1251 "КонецДокумента")) (w-br)
             ))
         documents)
    (write-bytes (string->bytes1251 "КонецФайла")) (w-br)
    (void)))

(define (export-1c-a.perform)
  (let ([file (bytes1251->string (cadr (assq 'FileName export.params)))])
    (if (file-exists? file)
        (delete-file file))
    (with-output-to-file file export-1c-a.write)))
