(define export '(export
                 (forms export-bsclient-a.form
                        ;form-export-epd-b
                        )))

(define export-bsclient-a.form.ds
  (ds.table-extend
   'Custom
   (quasiquote
    ((FileName 0 LongString "Имя файла" (select-file))))))

(define export-bsclient-a.form
  (quasiquote
   (form
    (caption "Файл формата BS-Client")
    (export epd)
    (handler export-bsclient-a)
    (dataset export-bsclient-a.form.ds)
    (layout (v FileName)))))

(define (export-bsclient-a.require) '(FileName From To Firm Partner))

(define (export-bsclient-a.x) export.params)

(define (export-bsclient-a.ds)
  (quasiquote
   (dataset
    (extend
     (PayType
      (mode extend)
      (index 0)
      (type ShortString)
      (caption "Вид платежа"))
     (State
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Статус"))
     (PayKind
      (mode extend)
      (index 2)
      (type ShortString))
     (PayDate
      (mode extend)
      (index 3)
      (type Date))
     (PayOrd
      (mode extend)
      (index 4)
      (type ShortString))
     (PayCode
      (mode extend)
      (index 5)
      (type ShortString))
     (PClass
      (mode extend)
      (index 6)
      (type KBK))
     (POKAT
      (mode extend)
      (index 7)
      (type Okato))
     (PBase
      (mode extend)
      (index 8)
      (type ShortString))
     (PPeriod
      (mode extend)
      (index 9)
      (type ShortString))
     (PNum
      (mode extend)
      (index 10)
      (type ShortString))
     (PDocDt
      (mode extend)
      (index 11)
      (type ShortString))
     (PKind
      (mode extend)
      (index 12)
      (type ShortString))
     (Purpose
      (mode extend)
      (index 13)
      (type MemoString))
     (NDS
      (mode extend)
      (index 14)
      (type Percent)
      (caption "НДС"))
     (No2ndSign
      (mode extend)
      (index 15)
      (type LongString))
     (NoNDS
      (mode extend)
      (index 16)
      (type LongString))
     (NDSStr
      (mode extend)
      (index 17)
      (type LongString)))
    (fields (Doc Type Name Date PayType PayKind PayDate PayOrd PayCode Purpose NDSStr State
                 (PClass Name) (POKAT Name) PBase PPeriod PNum PDocDt PKind
                 (Firm FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep)
                 (Partner FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep) Sum NDS No2ndSign NoNDS)))))

(define (export-bsclient-a.query)
  (qu.set-part (ds.q-select (export-bsclient-a.ds)) 'where
               (mix "WHERE" br "  (r_Doc.\"fType\" = 'doc-pay-order')"
                    (eu.nnvl 'Firm " and (r_Doc.\"fFirm\" = '?')")
                    (eu.nnvl 'Partner " and (r_Doc.\"fPartner\" = '?')")
                    (eu.nnvl 'From " and (r_Doc.\"fDate\" >= '?')")
                    (eu.nnvl 'To " and (r_Doc.\"fDate\" <= '?')"))))

(define (export-bsclient-a.numerate start src)
  (if (null? src)
      null
      (cons start (export-bsclient-a.numerate (+ start 1) (cdr src)))))

(define utf8->dos866-table
  '((#\А #x80) (#\Б #x81) (#\В #x82) (#\Г #x83) (#\Д #x84) (#\Е #x85) (#\Ё #xf0) (#\Ж #x86)
               (#\З #x87) (#\И #x88) (#\Й #x89) (#\К #x8a) (#\Л #x8b) (#\М #x8c) (#\Н #x8d) (#\О #x8e)
               (#\П #x8f) (#\Р #x90) (#\С #x91) (#\Т #x92) (#\У #x93) (#\Ф #x94) (#\Х #x95) (#\Ц #x96)
               (#\Ч #x97) (#\Ш #x98) (#\Щ #x99) (#\Ъ #x9a) (#\Ы #x9b) (#\Ь #x9c) (#\Э #x9d) (#\Ю #x9e)
               (#\Я #x9f) (#\а #xa0) (#\б #xa1) (#\в #xa2) (#\г #xa3) (#\д #xa4) (#\е #xa5) (#\ё #xf1)
               (#\ж #xa6) (#\з #xa7) (#\и #xa8) (#\й #xa9) (#\к #xaa) (#\л #xab) (#\м #xac) (#\н #xad)
               (#\о #xae) (#\п #xaf) (#\р #xe0) (#\с #xe1) (#\т #xe2) (#\у #xe3) (#\ф #xe4) (#\х #xe5)
               (#\ц #xe6) (#\ч #xe7) (#\ш #xe8) (#\щ #xe9) (#\ъ #xea) (#\ы #xeb) (#\ь #xec) (#\э #xed)
               (#\ю #xee) (#\я #xef) (#\№ #xfc)))

(define utf8->dos866-hash
  (make-immutable-hash-table
   (map (lambda (item)
          (let ([key (car item)]
                [val (cadr item)])
            (list (char->integer key) val)))
        utf8->dos866-table)))

(define (string->bytes866 str)
  (list->bytes (map (lambda (char)
                      (car (hash-table-get utf8->dos866-hash
                                           (char->integer char)
                                           (lambda () (list (char->integer char)))                                           
                                           )))
                    (string->list str))))

(define (b-1251->866 bytes)
  (string->bytes866 (bytes1251->string bytes)))

(define (export-bsclient-a.prepare)
  
  (define (epd-ord n)
    (string
     (if (< n 10)
         (integer->char (+ n 48))
         (integer->char (+ n 55)))))
  
  (let* ([now (seconds->date (current-seconds))]
         [day (date-day now)]
         [month (date-month now)]
         [form-file-name (ext-call 's1251 (ext-call 'form-get-variable 'FileName))]
         [ofk-dep-d (cadr (ext-call 'query-select (mix "SELECT \"fOfkDep\" FROM \"tFirm\" WHERE \"fObject\" = '" (ext-call 'form-get-variable 'Firm) "'")))]
         [ofk-dep (if (null? ofk-dep-d) "XXXXX" (subr (vector-ref (car ofk-dep-d) 0) 5 10))]
         [file-name (if (eq? (string-length form-file-name) 0) (build-path root-path "empty.ext") (string->path form-file-name))])
    
    (let-values ([(base name dir?) (split-path file-name)])
      (ext-call 'form-set-variable 'FileName (path->string (build-path base "bsclient.txt"))))))

(define (export-bsclient-a.write)
  
  (define (date->epd date)
    (let ([s (format "~a" date)])
      (if (or (equal? s "1899-12-30") (equal? s "1899-12-30 00:00:00.0000"))
          ""
          (mix (substring s 8 10) "." (substring s 5 7) "." (substring s 0 4)))))
  
  (define (bank-city b)
    (let 
        ([city (regexp-match "Г\\..+" (string-upcase (bytes1251->string b)))]) 
      (if city (car city) "")))
  
  (define (format-int n c)
    (let* ([s (number->string n)]
           [len (string-length s)])
      (if (< len c) 
          (string-append (make-string (- c len) #\0) s)
          s)))
  
  (let ([documents (tu.table-rows-by-name (ext-call 'query-select (export-bsclient-a.query)))])
    (map (lambda (row n)
           (let ([class-codes (tu.table-rows-by-name (ext-call 'query-select (mix "SELECT * FROM \"tClassCode\" WHERE \"fDoc\" = '" (row 'Object) "'")))])
             (display "#") (display n) (display "|PayDocRuXE") (w-br)
             (display (date->epd (row 'Date))) (w-br) ; Дата документа
             (write-bytes (row 'Name)) (w-br) ; Номер документа
             (display "810") (w-br) ; Код валюты документа
             (write-bytes (b-1251->866 (subr (row 'FirmRasDep) 0 20))) (w-br) ; Счет плательщика
             (write-bytes (b-1251->866 (row 'FirmFullName))) (w-br) ; Наименование плательщика
             (write-bytes (b-1251->866 (subr (row 'FirmKPP) 0 9))) (w-br) ; КПП плательщика
             (write-bytes (b-1251->866 (subr (row 'PartnerBIK) 0 9))) (w-br) ; БИК банка получателя
             (write-bytes (b-1251->866 (subr (row 'PartnerRasDep) 0 20))) (w-br) ; Счет получателя
             (write-bytes (b-1251->866 (row 'PartnerFullName))) (w-br) ; Наименование получателя
             (write-bytes (b-1251->866 (subr (row 'PartnerINN) 0 12))) (w-br) ; ИНН получателя
             (display (double->str2 (row 'Sum))) (w-br) ; Сумма документа
             (write-bytes (b-1251->866 (row 'Purpose))) (w-br) ; Основание платежа
             (write-bytes (b-1251->866 (row 'NDSStr))) (w-br) ; Информация об НДС в основании платежа
             (write-bytes (b-1251->866 (subr (row 'PayOrd) 0 2))) (w-br) ; Очередность платежа
             (display (date->epd (row 'PayDate))) (w-br) ; Срок платежа
             (write-bytes (b-1251->866 (subr (row 'PayKind) 0 2))) (w-br) ; Вид операции
             (w-br) ; Способ отправки
             (write-bytes (b-1251->866 (subr (row 'PartnerKPP) 0 9))) (w-br) ; КПП получателя
             (write-bytes (b-1251->866 (subr (row 'State) 0 2))) (w-br) ; Показательстатуса
             (write-bytes (b-1251->866 (subr (row 'PClassName) 0 20))) (w-br) ; Код бюджетной классификации
             (write-bytes (b-1251->866 (subr (row 'POKATName) 0 11))) (w-br) ; Код ОКАТО
             (write-bytes (b-1251->866 (subr (row 'PBase) 0 2))) (w-br) ; Показатель основания платежа
             (write-bytes (b-1251->866 (subr (row 'PPeriod) 0 2))) (w-br) ; Показатель налогового периода(код или число даты)
             (write-bytes (b-1251->866 (subr (row 'PPeriod) 3 5))) (w-br) ; Показатель налогового периода(период года или месяц даты)
             (write-bytes (b-1251->866 (subr (row 'PPeriod) 6 10))) (w-br) ; Показатель налогового периода(период иди год даты)
             (write-bytes (b-1251->866 (row 'PNum))) (w-br); Показатель номера документа
             (write-bytes (b-1251->866 (subr (row 'PDocDt) 0 2))) (w-br) ; Показатель даты документа(число месяца или 0)
             (write-bytes (b-1251->866 (subr (row 'PDocDt) 3 5))) (w-br) ; Показатель даты документа(месяц)
             (write-bytes (b-1251->866 (subr (row 'PDocDt) 6 10))) (w-br) ; Показатель даты документа(год)
             (write-bytes (b-1251->866 (subr (row 'PKind) 0 2))) (w-br) ; Показатель типа платежа
             (display ";end") (w-br)
             ))
         documents (export-bsclient-a.numerate 1 documents))
    (void)))

(define (export-bsclient-a.perform)
  (let ([file (bytes1251->string (cadr (assq 'FileName export.params)))])
    (if (file-exists? file)
        (delete-file file))
    (with-output-to-file file export-bsclient-a.write)))
