(define export '(export
                 (forms export-epd-a.form
                        ;form-export-epd-b
                        )))

(define export-epd-a.form.ds
  (ds.table-extend
   'Custom
   (quasiquote
    ((FileName 0 LongString "Имя файла" (select-file))))))

(define export-epd-a.form
  (quasiquote
   (form
    (caption "Файл ЭПД версия 2008.06")
    (export epd)
    (handler export-epd-a)
    (dataset export-epd-a.form.ds)
    (layout (v FileName)))))

(define (export-epd-a.require) '(FileName From To Firm Partner))

(define (export-epd-a.x) export.params)

(define (export-epd-a.ds)
  (quasiquote
   (dataset
    (extend
     (PayType
      (mode extend)
      (index 0)
      (type ShortString)
      (caption "Вид платежа"))
     (State
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Статус"))
     (PayKind
      (mode extend)
      (index 2)
      (type ShortString))
     (PayDate
      (mode extend)
      (index 3)
      (type Date))
     (PayOrd
      (mode extend)
      (index 4)
      (type ShortString))
     (PayCode
      (mode extend)
      (index 5)
      (type ShortString))
     (PClass
      (mode extend)
      (index 6)
      (type KBK))
     (POKAT
      (mode extend)
      (index 7)
      (type Okato))
     (PBase
      (mode extend)
      (index 8)
      (type ShortString))
     (PPeriod
      (mode extend)
      (index 9)
      (type ShortString))
     (PNum
      (mode extend)
      (index 10)
      (type ShortString))
     (PDocDt
      (mode extend)
      (index 11)
      (type ShortString))
     (PKind
      (mode extend)
      (index 12)
      (type ShortString))
     (Purpose
      (mode extend)
      (index 13)
      (type MemoString))
     (NDS
      (mode extend)
      (index 14)
      (type Percent)
      (caption "НДС"))
     (No2ndSign
      (mode extend)
      (index 15)
      (type LongString))
     (NoNDS
      (mode extend)
      (index 16)
      (type LongString))
     (NDSStr
      (mode extend)
      (index 17)
      (type LongString)))
    (fields (Doc Type Name Date PayDate PayOrd Purpose NDSStr State
                 (PClass Name) (POKAT Name) PBase PPeriod PNum PDocDt PKind
                 (Firm FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep)
                 (Partner FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep) Sum)))))

(define (export-epd-a.query)
  (qu.set-part (ds.q-select (export-epd-a.ds)) 'where
               (mix "WHERE" br "  (r_Doc.\"fType\" = 'doc-pay-order')"
                    (eu.nnvl 'Firm " and (r_Doc.\"fFirm\" = '?')")
                    (eu.nnvl 'Partner " and (r_Doc.\"fPartner\" = '?')")
                    (eu.nnvl 'From " and (r_Doc.\"fDate\" >= '?')")
                    (eu.nnvl 'To " and (r_Doc.\"fDate\" <= '?')"))))

(define (export-epd-a.prepare)
  
  (define (epd-ord n)
    (string
     (if (< n 10)
         (integer->char (+ n 48))
         (integer->char (+ n 55)))))
  
  (let* ([now (seconds->date (current-seconds))]
         [day (date-day now)]
         [month (date-month now)]
         [form-file-name (ext-call 's1251 (ext-call 'form-get-variable 'FileName))]
         [ofk-dep-d (cadr (ext-call 'query-select (mix "SELECT \"fOfkDep\" FROM \"tFirm\" WHERE \"fObject\" = '" (ext-call 'form-get-variable 'Firm) "'")))]
         [ofk-dep (if (null? ofk-dep-d) "XXXXX" (subr (vector-ref (car ofk-dep-d) 0) 5 10))]
         [file-name (if (eq? (string-length form-file-name) 0) (build-path root-path "empty.ext") (string->path form-file-name))])
    
    (let-values ([(base name dir?) (split-path file-name)])
      (ext-call 'form-set-variable 'FileName (path->string (build-path base (mix ofk-dep (epd-ord day) "01.PP" (epd-ord month))))))))

(define (export-epd-a.write)
  
  (define (date->epd date)
    (let ([s (format "~a" date)])
      (if (equal? s "1899-12-30")
          ""
          (mix (substring s 8 10) "." (substring s 5 7) "." (substring s 0 4)))))
  
  (define (double->epd d)
    (inexact->exact (round (* 100.0 d))))
  
  (let ([documents (tu.table-rows-by-name (ext-call 'query-select (export-epd-a.query)))])
    (display "FK|2008.06||||") (w-br)
    (map (lambda (row)
           (let ([class-codes (tu.table-rows-by-name (ext-call 'query-select (mix "SELECT * FROM \"tClassCode\" WHERE \"fDoc\" = '" (row 'Object) "'")))])
             (display "PP|")
             (write-bytes (row 'Name)) (display "|")
             (display (date->epd (row 'Date))) (display "|")
             (display 3) (display "|")
             (display (double->epd (row 'Sum))) (display "|")
             (write-bytes (row 'FirmINN)) (display "|")
             (write-bytes (row 'FirmKPP)) (display "|")
             (write-bytes (subr (row 'FirmOfkDep) 5 10)) (display "|")
             (write-bytes (row 'FirmOfkOrg)) (display " (") (write-bytes (row 'FirmFullName)) (display ")") (display "|")
             (write-bytes (row 'FirmOfkDep)) (display "|")
             (write-bytes (row 'FirmOfkCode)) (display "|")
             (write-bytes (row 'FirmOfkINN)) (display "|")
             (write-bytes (row 'FirmOfkOrg)) (display "|")
             (write-bytes (row 'FirmRasDep)) (display "|")
             (write-bytes (row 'FirmBIK)) (display "|")
             (write-bytes (row 'FirmBank)) (display "|")
             (display "|") ; FILIAL_PAY
             (write-bytes (row 'FirmCorDep)) (display "|")
             (write-bytes (row 'PartnerINN)) (display "|")
             (write-bytes (row 'PartnerKPP)) (display "|")
             (write-bytes (row 'PartnerFullName)) (display "|")
             (write-bytes (row 'PartnerOfkINN)) (display "|")
             (write-bytes (row 'PartnerOfkOrg)) (display "|")
             (write-bytes (row 'PartnerRasDep)) (display "|")
             (write-bytes (row 'PartnerOfkDep)) (display "|")
             (write-bytes (row 'PartnerBIK)) (display "|")
             (write-bytes (row 'PartnerBank)) (display "|")
             (display "|") ; FILIAL_RCP
             (write-bytes (row 'PartnerCorDep)) (display "|")
             (display (date->epd (row 'PayDate))) (display "|")
             (write-bytes (row 'PayOrd)) (display "|")
             
             (map (lambda (row) (write-bytes (row 'Formed))) class-codes)
             (write-bytes (row 'Purpose)) (display " ") (write-bytes (row 'NDSStr)) (display "|")
             
             (display "1") (display "|") ; PRINT_KPP
             (write-bytes (row 'State)) (display "|")
             (write-bytes (row 'PClassName)) (display "|")
             (write-bytes (row 'POKATName)) (display "|")
             (write-bytes (row 'PBase)) (display "|")
             (write-bytes (row 'PPeriod)) (display "|")
             (write-bytes (row 'PNum)) (display "|")
             (write-bytes (row 'PDocDt)) (display "|")
             (write-bytes (row 'PKind)) (display "|")
             (w-br)
             (map (lambda (row)
                    (display "PPST|")
                    (write-bytes (row 'GLAVA)) (display "|")
                    (write-bytes (row 'RAZDEL)) (display "|")
                    (write-bytes (row 'VID)) (display "|")
                    (write-bytes (row 'KOD_FP)) (display "|")
                    (write-bytes (row 'E_KLASS)) (display "|")
                    (write-bytes (row 'KKIVNF)) (display "|")
                    (write-bytes (row 'KKIVF)) (display "|")
                    (write-bytes (row 'KDOH)) (display "|")
                    (write-bytes (row 'NUM_BO)) (display "|")
                    (write-bytes (row 'MON_FIN)) (display "|")
                    (display (double->epd (row 'SUM_STR))) (display "|")
                    (display "|")
                    (w-br)
                    ) class-codes)
             ))
         documents)
    (void)))

(define (export-epd-a.perform)
  (let ([file (bytes1251->string (cadr (assq 'FileName export.params)))])
    (if (file-exists? file)
        (delete-file file))
    (with-output-to-file file export-epd-a.write)))

;(define ds-custom
;  (quasiquote
;   (dataset
;    (fields (Custom Page Field1)))))
;
;(define form-export-epd-b
;  (quasiquote
;   (form
;    (caption "EPD-B")
;    (export epd)
;    (dataset ds-custom)
;    (layout (v Field1)))))
