(define export '(export
                 (forms export-receive-request-a.form
                        export-receive-request-a090810.form)))

(define export-receive-request-a.form.ds
  (ds.table-extend
   'Custom
   (quasiquote
    ((FileName 0 LongString "Имя файла" (select-file))))))

(define export-receive-request-a.form
  (quasiquote
   (form
    (caption "Заявка на получение наличных денег TXZS090101")
    (export receive-request)
    (handler export-receive-request-a)
    (dataset export-receive-request-a.form.ds)
    (layout (v FileName)))))

(define export-receive-request-a090810.form
  (quasiquote
   (form
    (caption "Заявка на получение наличных денег TXZS090810")
    (export receive-request)
    (handler export-receive-request-a090810)
    (dataset export-receive-request-a.form.ds)
    (layout (v FileName)))))

(define (export-receive-request-a.require) '(FileName From To Firm Partner))

(define (export-receive-request-a.x) export.params)

(define (export-receive-request-a.ds)
  (quasiquote
   (dataset
    (extend
     (DateIsp
      (mode extend)
      (index 0)
      (type Date)
      (caption "Предельная дата исполнения"))
     (NumBO
      (mode extend)
      (index 1)
      (type ShortString)
      (caption "Номер обязательства")))
    (fields (Doc SumMethod Precision Type Curr ByCurr
                 (Firm FullName INN KPP OfkOrg OfkDep OfkCode OfkINN Bank BIK RasDep CorDep 
                       OfkGlavaGRS OfkNameUBPGRS OfkNBudg OfkNameFO OfkCodeOrg OfkBudgLevel OfkCodeUBP OfkNameUBP)
                 Date Name Num Sum DateIsp NumBO)))))

(define export-receive-request-a.ds-subdoc
  (quasiquote
   (dataset
    (fields (SubSubDocR (SubDocR Doc SumR CheckNum CheckSer CheckDate CheckDateLim CheckKas) 
                        CodeIst (KBK Name) TypeKBK AddKlass SumRKBK Purpose Note OrderA)))))

(define (export-receive-request-a.query)
  (qu.set-part (qu.set-part (ds.q-select (export-receive-request-a.ds)) 'where
                            (mix "LEFT OUTER JOIN \"tPeople\" r_Doc_Firm_Chief ON"
                                 " (r_Doc_Firm_Chief.\"fObject\" ="
                                 " (SELECT \"fValue\" FROM \"tMutualRef\""
                                 " WHERE \"fOwner0\" = r_Doc.\"fObject\" AND \"fOwner1\" = r_Doc.\"fFirm\" AND \"fName\" = 'Chief.doc-receive-request'))"
                                 "LEFT OUTER JOIN \"tDutie\" r_Doc_Firm_Chief_Dutie ON"
                                 " (r_Doc_Firm_Chief_Dutie.\"fObject\" = r_Doc_Firm_Chief.\"fDutie\") "
                                 "LEFT OUTER JOIN \"tPeople\" r_Doc_Firm_Accountant ON"
                                 " (r_Doc_Firm_Accountant.\"fObject\" ="
                                 " (SELECT \"fValue\" FROM \"tMutualRef\""
                                 " WHERE \"fOwner0\" = r_Doc.\"fObject\" AND \"fOwner1\" = r_Doc.\"fFirm\" AND \"fName\" = 'Accountant.doc-receive-request'))"
                                 "LEFT OUTER JOIN \"tDutie\" r_Doc_Firm_Accountant_Dutie ON"
                                 " (r_Doc_Firm_Accountant_Dutie.\"fObject\" = r_Doc_Firm_Accountant.\"fDutie\") "
                                 "LEFT OUTER JOIN \"tPeople\" r_Doc_Person ON"
                                 " (r_Doc_Person.\"fObject\" ="
                                 " (SELECT \"fValue\" FROM \"tMutualRef\""
                                 " WHERE \"fOwner0\" = r_Doc.\"fObject\" AND \"fOwner1\" = r_Doc.\"fFirm\" AND \"fName\" = 'Person.doc-receive-request'))"
                                 "LEFT OUTER JOIN \"tDutie\" r_Doc_Person_Dutie ON"
                                 " (r_Doc_Person_Dutie.\"fObject\" = r_Doc_Person.\"fDutie\") "
                                 "WHERE r_Doc.\"fObject\" = '" (ext-call 'form-get-variable "Docs.Current") "'"))
               'fields ", CASE r_Doc.\"fByCurr\" WHEN '1' THEN (SELECT \"fCodeOKV\" FROM \"tCurr\" c WHERE c.\"fObject\" = r_Doc.\"fCurr\") ELSE '643' END \"fCurrCodeOKV\",
  r_Doc_Firm_Chief.\"fFirstName\" \"fFirmChiefFirstName\",
  r_Doc_Firm_Chief.\"fSecondName\" \"fFirmChiefSecondName\",
  r_Doc_Firm_Chief.\"fLastName\" \"fFirmChiefLastName\",
  r_Doc_Firm_Chief_Dutie.\"fName\" \"fFirmChiefDutieName\",
  r_Doc_Firm_Accountant.\"fFirstName\" \"fFirmAccountantFirstName\",
  r_Doc_Firm_Accountant.\"fSecondName\" \"fFirmAccountantSecondName\",
  r_Doc_Firm_Accountant.\"fLastName\" \"fFirmAccountantLastName\",
  r_Doc_Firm_Accountant_Dutie.\"fName\" \"fFirmAccountantDutieName\",
  r_Doc_Person.\"fFirstName\" \"fPersonFirstName\",
  r_Doc_Person.\"fSecondName\" \"fPersonSecondName\",
  r_Doc_Person.\"fLastName\" \"fPersonLastName\",
  r_Doc_Person.\"fPspType\" \"fPersonPspType\",
  r_Doc_Person.\"fPspSer\" \"fPersonPspSer\",
  r_Doc_Person.\"fPspNum\" \"fPersonPspNum\",
  r_Doc_Person.\"fPspGive\" \"fPersonPspGive\",
  r_Doc_Person.\"fPspDate\" \"fPersonPspDate\",
  r_Doc_Person_Dutie.\"fName\" \"fPersonDutieName\""))

(define (export-receive-request-a.prepare)
  
  (define (epd-ord n)
    (string
     (if (< n 10)
         (integer->char (+ n 48))
         (integer->char (+ n 55)))))
  
  (let* ([now (seconds->date (current-seconds))]
         [day (date-day now)]
         [month (date-month now)]
         [form-file-name (ext-call 's1251 (ext-call 'form-get-variable 'FileName))]
         [ofk-code-d (cadr (ext-call 'query-select (mix "SELECT \"fOfkCode\" FROM \"tDoc\" d LEFT OUTER JOIN \"tFirm\" f ON d.\"fFirm\" = f.\"fObject\" WHERE d.\"fObject\" = '" (ext-call 'form-get-variable "Docs.Current") "'")))]
         [ofk-code (if (null? ofk-code-d) "XXXXX" (vector-ref (car ofk-code-d) 0))]
         [file-name (if (eq? (string-length form-file-name) 0) (build-path root-path "empty.ext") (string->path form-file-name))])
    
    (let-values ([(base name dir?) (split-path file-name)])
      (ext-call 'form-set-variable 'FileName (path->string (build-path base (mix ofk-code (epd-ord day) "01.ZS" (epd-ord month))))))))

(define (mk-export-receive-request-a.write version)
  (lambda ()
    
    (define (date->epd date)
      (let ([s (format "~a" date)])
        (if (equal? s "1899-12-30")
            ""
            (mix (substring s 8 10) "." (substring s 5 7) "." (substring s 0 4)))))
    
    (let ([documents (tu.table-rows-by-name (ext-call 'query-select (export-receive-request-a.query)))])
      (display (mix "FK|TXZS" version "||||")) (w-br)
      (map (lambda (row)
             (display "FROM|")
             (write-bytes (subr (row 'FirmOfkBudgLevel) 0 1)) (display "|") ;BUDG_LEVEL
             (write-bytes (subr (row 'FirmOfkCodeUBP) 0 5)) (display "|") ;KOD_UBP
             (write-bytes (row 'FirmOfkNameUBP)) (display "|") ;NAME_UBP
             (w-br)
             (display "TO|")
             (write-bytes (subr (row 'FirmOfkCodeOrg) 0 4)) (display "|") ;KOD_TOFK
             (write-bytes (row 'FirmOfkOrg)) (display "|") ;NAME_TOFK
             (w-br)
             (display "ZS|")
             (display "|") ;GUID_FK
             (write-bytes (subr (row 'Name) 0 15)) (display "|") ;NOM_ZVK
             (display (date->epd (row 'Date))) (display "|") ;DATE_ZVK
             (write-bytes (row 'FirmOfkNBudg)) (display "|") ;NAME_BUD
             (write-bytes (row 'FirmOfkNameFO)) (display "|") ;NAME_UBP_FO
             (write-bytes (row 'FirmOfkNameUBPGRS)) (display "|") ;NAME_GRBS
             (write-bytes (subr (row 'FirmOfkGlavaGRS) 0 3)) (display "|") ;GLAVA_GRBS
             (write-bytes (row 'FirmFullName)) (display "|") ;NAME_UBP_PAY
             (write-bytes (subr (row 'FirmOfkCode) 0 5)) (display "|") ;KOD_UBP_PAY
             (write-bytes (subr (row 'FirmOfkDep) 0 11)) (display "|") ;LS_PAY
             (write-bytes (row 'FirmOfkOrg)) (display "|") ;NAME_TOFK_PAY
             (write-bytes (subr (row 'FirmOfkCodeOrg) 0 4)) (display "|") ;KOD_TOFK_PAY
             (display (date->epd (row 'DateIsp))) (display "|") ;DATE_LIM
             (write-bytes (subr (row 'NumBO) 0 16)) (display "|") ;NOM_BO
             (write-bytes (subr (row 'FirmChiefDutieName) 0 100)) (display "|") ;DOL_RUK
             (write-bytes (subr (bytes-append (row 'FirmChiefSecondName) #" " (row 'FirmChiefFirstName) #" " (row 'FirmChiefLastName)) 0 50)) (display "|") ;NAME_RUK
             (write-bytes (subr (row 'FirmAccountantDutieName) 0 100)) (display "|") ;DOL_BUH
             (write-bytes (subr (bytes-append (row 'FirmAccountantSecondName) #" " (row 'FirmAccountantFirstName) #" " (row 'FirmAccountantLastName)) 0 50)) (display "|") ;NAME_BUH
             (display (date->epd (row 'Date))) (display "|") ;DATE_POD
             (write-bytes (subr (row 'PersonDutieName) 0 100)) (display "|") ;DOL_ISP_DOV
             (write-bytes (subr (bytes-append (row 'PersonSecondName) #" " (row 'PersonFirstName) #" " (row 'PersonLastName)) 0 50)) (display "|") ;NAME_ISP_DOV
             (write-bytes (subr (row 'PersonPspType) 0 255)) (display "|") ;NAME_DOV
             (write-bytes (subr (bytes-append (row 'PersonPspSer) #" " (row 'PersonPspNum)) 0 20)) (display "|") ;NOM_DOC
             (write-bytes (row 'PersonPspGive)) (display "|") ;ORG_DOC 
             (display (date->epd  (row 'PersonPspDate))) (display "|") ;DATE_DOC 
             (display (double->str2 (row 'Sum))) (display "|") ;SUM_ITOG
             (display "|") ;NOM_ZS_FK
             (display "|") ;DATE_FK
             (display "|") ;DOL_ISP_FK
             (display "|") ;NAME_ISP_FK
             (display "|") ;TEL_ISP_FK
             (w-br) 
             (let ([subdoc (tu.table-rows-by-name (ext-call 'query-select (mix (ds.q-select export-receive-request-a.ds-subdoc) "WHERE r_SubSubDocR_SubDocR.\"fDoc\" = '" (row 'Object) "'")))])
               (map (lambda (subrow)
                      (display "ZSCH1|")
                      (display (double->str2 (subrow 'SubDocRSumR))) (display "|") ;SUMR_ZVK
                      (write-bytes (subr (subrow 'SubDocRCheckNum) 0 15)) (display "|") ;CHECK_NOM
                      (write-bytes (subr (subrow 'SubDocRCheckSer) 0 30)) (display "|") ;CHECK_SER
                      (display (date->epd (subrow 'SubDocRCheckDate))) (display "|") ;DATE_CHECK
                      (display (date->epd (subrow 'SubDocRCheckDateLim))) (display "|") ;DATE_CHECK_LIM
                      (write-bytes (subr (subrow 'SubDocRCheckKas) 0 2)) (display "|") ;CHECK_KAS
                      (w-br)
                      (display "ZSCH2|")
                      (write-bytes (subr (subrow 'CodeIst) 0 1)) (display "|") ;KOD_IST
                      (write-bytes (subr (subrow 'KBKName) 0 20)) (display "|") ;KBK
                      (write-bytes (subr (subrow 'TypeKBK) 0 2)) (display "|") ;TYPE_KBK
                      (write-bytes (subr (subrow 'AddKlass) 0 20)) (display "|") ;ADD_KLASS
                      (display (double->str2 (subrow 'SumRKBK))) (display "|") ;SUMR_KBK
                      (write-bytes (subr (subrow 'Purpose) 0 210)) (display "|") ;PURPOSE
                      (write-bytes (subr (subrow 'Note) 0 254)) (display "|") ;NOTE
                      (w-br)
                      ) subdoc)
               ))
           documents)
      (void))))

(define (export-receive-request-a.perform)
  (let ([file (bytes1251->string (cadr (assq 'FileName export.params)))])
    (if (file-exists? file)
        (delete-file file))
    (with-output-to-file file (mk-export-receive-request-a.write "090101"))))

(define export-receive-request-a090810.prepare export-receive-request-a.prepare)
(define export-receive-request-a090810.require export-receive-request-a.require)

(define (export-receive-request-a090810.perform)
  (let ([file (bytes1251->string (cadr (assq 'FileName export.params)))])
    (if (file-exists? file)
        (delete-file file))
    (with-output-to-file file (mk-export-receive-request-a.write "090810"))))
