(module alists
  mzscheme
  
  (require "list.ss"
           (prefix u. "utils.scm"))
  
  (provide node
           val
           val*
           val1
           merge
           tree-map
           ;safe-assq
           )
  
  ;(define (safe-assq key list)
  ;  (if list
  ;      (assq key list)
  ;      #f))
  
  (define (node0 alist v)
    (if (null? v)
        alist
        (if alist
            (node0 (assq (car v) (cdr alist)) (cdr v))
            #f)))
  
  (define (node alist . v)
    (if (and (pair? v) (list? (car v)))
        (node0 alist (car v))
        (node0 alist v)))
  
  (define (val alist . v)
    (u.safe-cdr
     (if (and (pair? v) (list? (car v)))
         (node0 alist (car v))
         (node0 alist v))))
  
  (define (val* alist . v); warning: this version of val not accept list as parameter
    (let ([result (val alist v)])
      (if result
          result
          null)))
  
  (define (val1 alist . v)
    (u.safe-cadr
     (if (and (pair? v) (list? (car v)))
         (node0 alist (car v))
         (node0 alist v))))
  
  (define (merge base from)
    
    (define (merge-base b)
      (if (null? b)
          (filter (lambda (item) (not (assq (car item) base))) from)
          (cons
           (let* ([item-base (car b)]
                  [name (car item-base)]
                  [item-from (assq name from)])
             (if item-from
                 item-from
                 item-base))
           (merge-base (cdr b)))))
    
    (if from
        (if base
            (merge-base base)
            from)
        base))
  
  (define (tree-map proc tree)
    
    (define (t-m tree lead path)
      (if (null? tree)
          null
          (let* ([item (car tree)]
                 [rest (cdr tree)])
            (cons (if (list? item)
                      (let ([new-path (append path (list (car item)))])
                        (t-m (proc item 'node new-path) #t new-path))
                      (proc item (if lead 'lead 'item) path))
                  (t-m rest #f path)))))
    
    (t-m tree #t (list (car tree))))
  
  )

#|;flatten common template
(define (flatten ds pad)
  (if (null? ds)
      (if (null? pad)
          null
          (flatten (car pad) (cdr pad)))
      (let ([head (car ds)]
            [tail (cdr ds)])
        (if (list? head)
            (flatten (cdr head) (cons tail pad))
            (cons head (flatten tail pad))))))
|#

#|(require alists)

(define n1
  (quasiquote
   (node
    (val1 1 2 3)
    (val2 a b c)
    (val3 Preved))))

(define n2
  (quasiquote
   (node
    (val1 9 8 7)
    (val2 q w e)
    (nal3 Preved))))


(merge (cdr n1) (cdr n2))
|#