(define (safe-eval-cd symbol)
  (with-handlers ([exn:fail?
                   (lambda (exn) #f)])
    (eval symbol)))

(define root-path (let ([host-r-p (safe-eval-cd 'host-root-path)]) (if host-r-p (string->path host-r-p) (simplify-path (build-path (current-directory) 'up)))))
(define operate-mode (let ([host-o-m (safe-eval-cd 'host-operate-mode)]) (if host-o-m host-o-m 'design)))

(if (and (eq? operate-mode 'design) (not (safe-eval-cd 'common-defs-loaded)))
    (load "design-defs.scm"))

(if (and (eq? operate-mode 'design) (safe-eval-cd 'design-imports-required) (not (safe-eval-cd 'design-imports-loaded)))
    (load "design-imports.scm"))

(if (and (eq? operate-mode 'design) (not (safe-eval-cd 'common-units-loaded)))
    (begin
      (load "common-form.scm")
      (load "common-ds.scm")))

(if (not (safe-eval-cd 'common-syntax-loaded))
    (load "common-syntax.scm"))

(define common-defs-loaded #t)
(define common-syntax-loaded #t)
(define common-units-loaded #t)
(define design-imports-loaded #t)
