(require
 "list.ss"
 "utils.scm")
;(prefix meta. "meta.scm")
;(prefix al. "alists.scm")
;(prefix ds. "dataset.scm"))

(define form-model-std
  (quasiquote
   (form
    (caption "Модель")
    (dataset ds-model-std)
    (visual
     (NDSMode
      (type Switch)
      (caption none)
      (values ([0 "нет"] [1 "начислить"] [-1 "выделить"])))
     (Curr
      (form null))
     (Name
      (resize horizontal))
     (Coefficient
      (caption none)))
    (defaults ([Group Last]
               [NDS Last]
               [NDSMode Last]
               [Volume Last]))
    (layout (v Name Country GTD (h Volume Pack Coefficient "(коэффициент)") Price (h NDS NDSMode) Curr Group Note1 Note2))
    (groups ([Name Price Volume NDS Curr GTD Country Group Note1 Note2]))
    (styles ([Mini Price NDS Volume Curr Pack] [Micro Coefficient])))))

(define form-goods-std
  (quasiquote
   (form
    (tag ab bc cd)
    (caption "Товар")
    (dataset ds-form-goods)
    (resize minimal)
    (active-control Model)
    (controls
     (PriceSwitch
      (type PriceCurr)
      (bind ([Default PriceDisplay Default]
             [Price Master Price]
             [PriceDC Master PriceDC]
             [Doc Caller Object]
             [Precision Caller Precision]
             [Model Master Model]
             [DocCurr Caller Curr]
             [DocByCurr Caller ByCurr])))
     (PriceDisplay
      (type Float))
     (GroupFilter
      (type Reference)
      (dataset ds-group-min)
      (form form-group-std)
      (caption "Группа")
      (resize horizontal)
      (bind ([Default Model aGroup])))
     (CostView
      (type CostView)
      (bind ([Doc Master Doc]
             [Price Master Price]
             [Count Master Count]
             [NDS Master NDS]
             [NDSMode Master NDSMode]
             [SumMethod Caller SumMethod]
             [Precision Caller Precision]
             [ByCurr Caller ByCurr]
             [DocCurr Caller Curr]
             [GoodsCurr Master ModelCurr])))
     (ModelNotifier
      (type ObjectNotifier)
      (bind ([Object Master Model]
             [Volume Master Volume]
             [Country Master Country]
             [GTD Master GTD]
             [Price Master Price]
             [NDS Master NDS]
             [NDSMode Master NDSMode]
             [Pack Master Pack]
             [Coefficient Master Coefficient]
             [Const0 Master PriceDC])))
     (FineRelay
      (type Relay)
      (method "set-zero")
      (bind ([Notifier Master NDSMode]
             [Value Master NDS]))))
    (visual
     (NDSMode
      (type Switch)
      (caption none)
      (values ([0 "нет"] [1 "начислить"] [-1 "выделить"])))
     (Model
      (dataset ds-model-group-filter)
      (resize horizontal))
     (Coefficient
      (caption none)))
    (defaults ([Count 1]
               [Model Last]
               [GroupFilter Last]))
    (layout (v GroupFilter "--" Model Country GTD
               (h Volume Pack Coefficient "(коэффициент)")
               "--"
               Count (h ">Цена" PriceDisplay PriceSwitch) (h NDS NDSMode) CostView))
    (groups ([GroupFilter Model Country GTD Volume Count ">Цена" NDS]))
    (styles ([Mini Count NDS Volume Pack PriceDisplay]
             [Micro Coefficient]
             [Immediate Count PriceDisplay NDS])))))

(define duties-std
  '((Chief "Руководитель")
    (Accountant "Бухгалтер")
    (Cashier "Кассир")))

(define duties-std-a
  '((Chief "Руководитель")
    (Accountant "Бухгалтер")
    (Cashier "Кассир")
    (Supplier "Отпуск груза произвел")))

(define duties-std-b
  '((Chief "Руководитель")
    (MainAccountant "Главный бухгалтер")
    (Accountant "Бухгалтер")
    (Cashier "Кассир")))

(define (firm-people-controls f/p doc-type duties)
  (map (lambda (item)
         (let ([name (car item)]
               [caption (cadr item)])
           `(,name
              (type Reference)
              (caption ,caption)
              (dataset ds-people-min)
              (form (form-people-firm ',f/p ',doc-type ',name))
              (bind ([Default ,(mix "~Mutual" f/p) ,(mix name "." doc-type)]
                     [aFirm Master Object])))))
       duties))

(define (form-firm-std f/p)
  (quasiquote
   (form
    (caption "Фирма")
    (dataset ds-firm-std)
    (controls
     (Cargo
      (type Reference)
      (dataset ds-cargo-min)
      (bind ([Default Caller ,(mix f/p 'Cargo)]
             [aFirm Master Object]))
      (form form-cargo-std)))
    (visual
     (Chief
      (bind (auto-name [aFirm Master Object])))
     (Accountant
      (bind (auto-name [aFirm Master Object])))
     (Cashier
      (bind (auto-name [aFirm Master Object]))))
    (layout (v ShortName FullName ExtraName (h ">Грузоотправитель" Cargo) Self Address INN KPP RasDep CorDep Bank BIK OKPO NoSeal No2ndSign))
    (childs
     (ofk "ОФК" (v OfkOrg OfkCodeOrg OfkDep OfkINN OfkCode OfkOSB OfkNBudg OfkNameFO OfkGlavaGRS OfkNameUBPGRS 
                   OfkBudgLevel OfkCodeUBP OfkNameUBP))
     (employees "Сотрудники" (v Chief Accountant Cashier)))
    (groups ([ShortName FullName ExtraName ">Грузоотправитель" Self INN KPP RasDep CorDep Bank BIK OKPO NoSeal No2ndSign Address])))))

(define form-people-std
  (quasiquote
   (form
    (caption "Сотрудник")
    (dataset ds-people-std)
    (layout (v SecondName FirstName LastName Dutie TabNum Address  
               "--"
               PspType PspSer PspNum PspGive PspDate))
    (styles ([Mini PspSer PspNum])))))

(define mutual-firm
  '(MutualFirm
    (type MutualRef)
    (bind ([Owner0 Master Object]
           [Owner1 Master Firm]))))

(define mutual-partner
  '(MutualPartner
    (type MutualRef)
    (bind ([Owner0 Master Object]
           [Owner1 Master Partner]))))

(define (form-firm-doc f/p doc-type duties)
  (refine
   (quasiquote
    (form
     (caption "Фирма")
     (dataset ds-firm-doc)
     ,(append `(controls
                (ExtraFill
                 (type ExtraFill)
                 (bind ([FullName Master FullName]
                        [ExtraName Master ExtraName])))
                (NDSFill
                 (type NDSFill)
                 (bind ([FullName Master FullName]
                        [Address Master Address]
                        [INN Master INN]
                        [KPP Master KPP]
                        [IpOGRN Master IpOGRN])))
                (SelectBank
                 (type SelectBank)
                 (bind ([Bank Master Bank]
                        [BIK Master BIK]
                        [CorDep Master CorDep])))
                (Cargo
                 (type Reference)
                 (caption ,(if (eq? f/p 'Partner) "Грузополучатель" "Грузоотправитель"))
                 (dataset ds-cargo-min)
                 (bind ([Default ,(mix "~Mutual" f/p) ,(mix 'Cargo "." doc-type)]
                        [aFirm Master Object]))
                 (form form-cargo-std))
                (Validator
                 (type FirmValidator)
                 (bind ([INN INN Default]
                        [INN_Color INN TextColor]
                        [BIK BIK Default]
                        [RasDep RasDep Default]
                        [CorDep CorDep Default]
                        [RasDep_Color RasDep TextColor]
                        [CorDep_Color CorDep TextColor]))))
              (firm-people-controls f/p doc-type duties))
     (visual
      (ExtraName
       (actions ([ExtraFill "Заполнить автоматически"])))
      (INN
       (actions ([NDSFill "Заполнить реквизиты по ИНН"]))))
     (layout (v ShortName FullName ,(if (eq? f/p 'Firm) 'ExtraName) Cargo Self Address INN KPP RasDep CorDep Bank BIK OKPO OKDP Custom1 Custom2 (h No2ndSign NoSeal) NoNDS))
     (childs
      (ofk "ОФК" (v OfkOrg OfkCodeOrg OfkDep OfkINN OfkCode OfkOSB OfkNBudg OfkNameFO OfkGlavaGRS OfkNameUBPGRS
                    OfkBudgLevel OfkCodeUBP OfkNameUBP))
      (employees "Сотрудники" ,(cons 'v (map car duties)))
      (ip "ИП" (v IpOGRN (h "Свидетельство" "<>--") IpSvSer IpSvNum IpSvGive IpSvDate (h "Паспорт" "<>--") IpPspSer IpPspNum IpPspGive IpPspDate)))
     (groups ([ShortName FullName ExtraName Cargo Self INN KPP RasDep CorDep Bank BIK OKPO OKDP Address Custom1 Custom2 No2ndSign NoNDS]))
     (styles ([Mini IpSvSer IpSvNum IpPspSer IpPspNum]
              [Immediate INN RasDep CorDep]))))))

(define (form-people-firm f/p doc-type dutie . params)
  (refine
   (quasiquote
    (form
     (caption "Сотрудник")
     (dataset ds-people-form)
     ;(controls
     ; (Dutie
     ;  (type Reference)
     ;  (caption "Должность")
     ;  (dataset ds-dutie-min)
     ;  (form form-dutie-std)
     ;  (bind ([Default ,(mix "~Mutual" f/p) ,(mix dutie "Dutie" "." doc-type)]))))
     (visual
      (Car
       (dataset ds-car-min)
       (bind [auto-name (aFirm Master Firm)
                        (aType Const "car")])
       (form form-car-std)))
     (layout (v SecondName FirstName LastName Dutie TabNum Address  
                "--"
                PspType PspSer PspNum PspGive PspDate
                ,(if (param-val 'driver params) '(v (h "Водительское удостоверение" "<>--") CertSer CertNum CertClass CertGive CertDate Car))
                ))
     (groups ([SecondName FirstName LastName Dutie TabNum Address PspType PspSer PspNum PspGive PspDate CertSer CertNum CertClass CertGive CertDate Car]))
     (styles ([Mini PspSer PspNum CertSer CertNum CertClass]))))))

(define (ctrl-people f/p doc-type name . params)
  (refine
   `(,name
      (type Reference)
      ,(let ([caption (param-val 'caption params)]) (if caption `(caption ,caption)))
      (dataset ds-people-min)
      (form (form-people-firm ',f/p ',doc-type ',name (if ,(param-val 'driver params) '(driver #t) '(driver #f))))
      (bind ([Default ,(mix "Mutual" f/p) ,(mix name "." doc-type)]
             [aFirm Master ,f/p])))))

(define (ctrl-firm f/p doc-type duties caption)
  (let ([fname (if (eq? f/p 'Partner) 'partner 'firm)])
    (refine
     `(,f/p
        (dataset ,(mix 'ds- fname '-min))
        ,(if (eq? f/p 'Firm) '(bind (auto-name [aSelf Const True])))
        (form (form-firm-doc ',f/p ',doc-type ,duties))
        (caption ,caption)))))

;(form-firm-doc 'Firm 'doc-invoice duties-std)
;(form-people-firm 'Partner 'doc-invoice 'Chief)
;(ctrl-people 'Partner 'invoice 'SubAcc)
;(ctrl-firm 'Partner 'doc-invoice 'duties-std "Получатель")


(define form-cargo-std
  (quasiquote
   (form
    (caption "Грузоотправитель")
    (dataset ds-cargo-std)
    (controls
     (SelectBank
      (type SelectBank)
      (bind ([Bank Master Bank]
             [BIK Master BIK]
             [CorDep Master CorDep])))
     (CopyFirm
      (type CmdButton)
      (text "Скопировать реквизиты организации")
      (cmd BuiltIn FirmCargoCopy)))
    (layout (v Name Address INN KPP BIK Bank CorDep RasDep OKPO (h " " CopyFirm)))
    (groups ([Name Address INN KPP BIK Bank CorDep RasDep OKPO " "])))))

(define form-volume-std
  (quasiquote
   (form
    (caption "Ед. изм.")
    (dataset ds-volume-min)
    (layout (v Name OKEI)))))

(define form-dutie-std
  (quasiquote
   (form
    (caption "Должность")
    (dataset ds-dutie-min)
    (layout (v Name)))))

(define form-country-std
  (quasiquote
   (form
    (caption "Страна")
    (dataset ds-country-min)
    (layout (v Name)))))

(define form-group-std
  (quasiquote
   (form
    (caption "Группа")
    (dataset ds-group-min)
    (layout (v Name)))))

(define form-curr-std
  (quasiquote
   (form
    (caption "Валюта")
    (dataset ds-curr-std)
    (layout (v Name CodeOKV "--" 
               (h (v "Обозначения прописью" Lex_i_a Lex_i_b Lex_i_c Lex_f_a Lex_f_b Lex_f_c Lex_i_s Lex_f_s) 
                  (v "Пример" 
                     "рубль (1)" 
                     "рублей (5, 6, 7, 8, 9)" 
                     "рубля (2, 3, 4)" 
                     "копейка (1)" 
                     "копеек (5, 6, 7, 8, 9)" 
                     "копейки (2, 3, 4)" 
                     "руб."
                     "коп."))))
    (styles ([Mini Name Lex_i_a Lex_i_b Lex_i_c Lex_i_s Lex_f_a Lex_f_b Lex_f_c Lex_f_s CodeOKV]))
    (groups ([Name CodeOKV])))))

(define form-payment-std
  (quasiquote
   (form
    (caption "Оплата")
    (dataset ds-payment-min)
    (controls
     (PayDoc
      (type CmdButton)
      (text "Оплатить по документу")
      (cmd FillPayment)))
    (layout (v Desc Date Sum (h " " PayDoc);Curr
               ))
    (defaults ([Date Now]
               [Sum Payment.Rest]))
    (groups ([Desc Date Sum " "]))
    (styles ([Mini Sum])))))

(define (arch-form caption doc-type goods payments . params)
  (refine
   (quasiquote
    (form
     (caption ,caption)
     (dataset ds-arch)
     ,(if (param-val 'export params) `(export ,(param-val 'export params)))
     (extend ArchCommon ,(if payments 'ArchPayment))
     (controls
      (Docs
       (type Grid)
       (dataset ,(if (param-val 'ds-docs params) (param-val 'ds-docs params) `(ds-arch-docs ',doc-type)))
       (bind ([aFirm Master Firm]
              [aPartner Master Partner]
              [aFrom Master From]
              [aTo Master To]
              [aPayState Master PayState]))
       (form null)
       (columns ([Mark "Метка" 25 rw]
                 [Name "Номер"]
                 [Date "Дата"]
                 ,(if (param-val 'column-docs-pbase params) '[PBase "Основание платежа" 120])
                 [FirmShortName "Организация" 200]
                 ,(if (not (param-val 'hide-partner params)) '[PartnerShortName "Партнер" 200])
                 ,(if (param-val 'column-person-fio params) '[PersonFIO "Через кого" 120])
                 [Sum "Сумма"]
                 ,(if payments '[PaySum "Оплачено"])
                 ,(if payments '[PayState " " 20])))
       )
      ,(if goods
           '(Goods
             (type Grid)
             (dataset ds-goods-arch)
             (bind ([aDoc Docs Current]))
             (form null)
             (columns ([GoodsName "Наименование" 200]
                       [Count "Количество"]
                       [VolumeName "Ед. изм."]                
                       [Price "Цена"]))))
      ,(if goods
           `(CurDoc
             (type Reference)
             (dataset (ds-doc-min ',doc-type))
             (bind ([Default Docs Current]))
             (form null)))
      ,(if payments
           '(Payments
             (type Grid)
             (dataset ds-payment-std)
             (bind ([aDoc Docs Current]))
             (form form-payment-std)
             (columns ([Date "Дата"]
                       [Sum "Сумма"]
                       [Desc "Описание" 200]))))
      (CancelRange
       (type NullButton)
       (bind ([Firm Master Firm]
              [Partner Master Partner]
              [From Master From]
              [To Master To]
              [PayState Master PayState]
              ))))
     (visual
      (Firm
       (dataset ds-firm-min)
       (bind (auto-name [aSelf Const True]))
       (form null))
      (Partner
       (dataset ds-partner-min)
       (form null))
      ,(if payments
           '(PayState
             (type Combo)
             (mode string)
             (style Mini)
             (values (["<empty>" "Все"]
                      ["Payment.Full" "Опл."]
                      ["Payment.Empty Payment.Partial" "Не опл."]
                      ;["Payment.Partial" "Прочие"]
                      )))))
     ,(if (safe-eval 'customize.compact-archive)
          `(layout 
            (v (h CancelRange
                  (v From To)
                  (v (h "Организация" Firm) ,(if (not (param-val 'hide-partner params)) '(h ">Партнер" Partner)))
                  (v ,(if payments 'PayState)))
               (h Docs ,(if goods `(v "Товары" Goods ,(if payments '(v "Оплаты" Payments)))))))
          `(layout (t ("Документы" ,(if goods "Товары") ,(if payments "Оплаты"))
                      (v (h CancelRange
                            (v From To)
                            (v (h "Организация" Firm) ,(if (not (param-val 'hide-partner params)) '(h ">Партнер" Partner)))
                            (v ,(if payments 'PayState)))
                         Docs)
                      ,(if goods '(v (h "Документ:" CurDoc) Goods))
                      ,(if payments '(v Payments)))))
     (groups ([From To] ["Организация" ">Партнер"]))
     ))))

(define-doc form-subdoc-std
  (quasiquote
   (form
    (caption "Заявка на кассовый расход")
    (dataset ds-subdoc)
    (controls
     ,mutual-partner)
    (visual
     ,(ctrl-firm 'Partner $doc 'duties-std "Реквизиты контрагента")
     (OKATO
      (dataset ds-okato-min)
      (form form-okato-std))
     (KDOH
      (dataset ds-kbk-min)
      (bind [auto-name (aTypeKBK Const "tax")])
      (form form-kbk-std))
     (KBKPay
      (dataset ds-kbk-min)
      (bind [auto-name (aTypeKBK Const "pay")])
      (form form-kbk-std))
     (KBKRcp
      (dataset ds-kbk-min)
      (bind [auto-name (aTypeKBK Const "rcp")])
      (form form-kbk-std))
     (NDSMode
      (type Switch)
      (caption none)
      (values ([0 "нет"] [1 "начислить"] [-1 "выделить"])))
     (VidPL
      (type Combo)
      (mode string)
      (values (["0" "пусто"]
               ["1" "почтой"]
               ["2" "телеграфом"]
               ["3" "электронно"]
               ["4" "срочно"])))
     (CodeIstKBK
      (type Combo)
      (mode string)
      (values (["1" "средства бюджета"]
               ["2" "средства от приносящей доход деятельности"]
               ["3" "средства дополнительного бюджетного финансирования"]
               ["4" "средства для финансирования мероприятий по оперативно-розыскной деятельности"]
               ["5" "средства, поступающие во временное распоряжение бюджетных учреждений"])))
     )
    (layout (h (v "Реквизиты документа" 
                  "--"
                  (h Sum ">Вид платежа" VidPL)  
                  (h NDS NDSMode)
                  (h ">Очередность" OrderPL "Признак авансового платежа" TypeAP)
                  (h ">Назначение" Purpose) 
                  "--"
                  "Реквизиты налоговых платежей"
                  "--"
                  PayStatus KDOH OKATO OsnPL NalPer NumDok DateDok TypePL)
               "|"
               (v "Реквизиты документа - основания" 
                  "--"
                  VidOsn NumOsn DateOsn Osn 
                  "--"
                  "Расшифровка заявки на кассовый расход"
                  "--"
                  CodeIstKBK "--" KBKPay TypeKBKPay AddKlassPay "--" KBKRcp TypeKBKRcp AddKlassRcp "--" PurposeKBK NoteKBK
                  "--"
                  Partner) 
               ))
    (groups ([VidOsn NumOsn DateOsn Osn Partner CodeIstKBK
                     KBKPay TypeKBKPay AddKlassPay
                     KBKRcp TypeKBKRcp AddKlassRcp
                     PurposeKBK NoteKBK]
             [Sum NDS ">Очередность" ">Назначение"]))
    (styles ([Mini Sum NDS VidPL NumOsn OrderPL PayStatus OsnPL TypePL]))
    )))

(define form-expense-std
  (quasiquote
   (form
    (caption "Расход")
    (dataset ds-expense-form)
    (controls
     (SumCopy
      (type Relay)
      (method "copy-value")
      (bind ([Source SumVN Default]
             [Dest SumRN Default]))))
    (layout (v Date Number Name 
               (h ">По отчету" SumVN) 
               (h ">Принято к учету" SumRN)
               DinV CinV))
    (groups ([Date Number Name ">По отчету" ">Принято к учету" DinV CinV]))
    (styles ([Mini Number SumVN SumRN DinV CinV])))))

(define form-okato-std
  (quasiquote
   (form
    (caption "ОКАТО")
    (dataset ds-okato-min)
    (layout (v Name)))))

(define form-kbk-std
  (quasiquote
   (form
    (caption "КБК")
    (dataset ds-kbk-std)
    (controls
     (Validator
      (type KBKValidator)
      (bind ([KBK Name Default]
             [KBK_Color Name TextColor]))))
    (layout (v Name Desc))
    (styles ([Immediate Name])))))

(define form-car-std
  (quasiquote
   (form
    (caption "Автомобиль")
    (dataset ds-car-std)
    (layout (v StateNum Mark Model GarageNum
               ReleaseYear Engine Chassis Body VIN Color
               "--" "Паспорт транспортного средства" "--"
               PspSer PspNum
               "--" "Свидетельство о регистрации транспортного средства" "--"
               CertSer CertNum CertDate CertGive))
    (styles ([Mini PspSer PspNum CertSer CertNum])))))

(define form-goodsc-std
  (quasiquote
   (form
    (caption "Сведения о грузе")
    (dataset ds-form-goodsc)
    (layout (v Name Note PackType PackNum MassMode Code Container Class Mass))
    (styles ([Mini PackNum Mass])))))