(module ddl-index
  mzscheme
  
  (require (prefix meta. "meta.scm")
           (prefix al. "alists.scm")
           "utils.scm")
  
  (provide create-index-ddl
           drop-index-ddl)
  
  (define meta meta.raw_meta)
  
  (define (initials index)
    (list->string (map (lambda (field) (string-ref (symbol->string field) 0)) index)))
  
  (define (enum-list alist)
    
    (define (e-l alist index)
      (if (null? alist)
          null
          (cons index (e-l (cdr alist) (+ 1 index)))))
    
    (e-l alist 0))
  
  (define (create-index-ddl)
    (apply
     string-append
     (apply
      append 
      (let ([itabs (al.val meta 'indexes)])
        (map (lambda (tab t-id)
               (let ([tname (car tab)]
                     [indexes (cdr tab)])
                 (map (lambda (index i-id)
                        (let ([iname (mix "I_" tname t-id "_" (initials index) i-id)])
                          (mix "CREATE INDEX " iname " ON \"t" tname "\" ("
                               (concat-str (map (lambda (field) (mix "\"f" field "\"")) index) ", ")
                               ");" br)))
                      indexes (enum-list indexes))))
             itabs (enum-list itabs))))))
  
  (define (drop-index-ddl)
    (apply
     string-append
     (apply
      append 
      (let ([itabs (al.val meta 'indexes)])
        (map (lambda (tab t-id)
               (let ([tname (car tab)]
                     [indexes (cdr tab)])
                 (map (lambda (index i-id)
                        (let ([iname (mix "I_" tname t-id "_" (initials index) i-id)])
                          (mix "DROP INDEX " iname ";" br)))
                      indexes (enum-list indexes))))
             itabs (enum-list itabs))))))
  
  )
