(module ddl-utils
  mzscheme
  
  (require "utils.scm")
  
  (provide display-pre proc-head
           display-post
           proc-pre-ddl
           proc-dis-ddl
           proc-del-ddl)
  
  (define proc-head (regexp "PROCEDURE.+\\)[\u0001-\u0020]+AS"))
  
  (define (proc-pre-ddl ddl)
    (mix "CREATE " (car (regexp-match proc-head ddl)) br
         "BEGIN" br
         "  IF (1 = 2) THEN SUSPEND;" br
         "END;"))
  
  (define (display-pre proc)
    (display (proc-pre-ddl (caddr proc)))
    (newline)
    (newline))
  
  (define (display-post proc)
    (display (caddr proc))
    (newline)
    (newline))
  
  (define (proc-dis-ddl proc)
    (let ([ddl (caddr proc)])
      (mix "ALTER " (car (regexp-match proc-head ddl)) br
           "BEGIN" br
           "  IF (1 = 2) THEN SUSPEND;" br
           "END;" br br)))
  
  (define (proc-del-ddl proc)
    (mix "DROP PROCEDURE \"" (cadr proc) "\";" br))
  
  
  
  )

#|

(require ddl-utils)

(define p1 '(procedure
  "pFirmDelete"
  "ALTER PROCEDURE \"pFirmDelete\" (\n  \"aObject\" CHAR(12))\nAS\n  DECLARE VARIABLE lChild CHAR(12);\nBEGIN\n  UPDATE\n    \"tFirm\" t\n  SET\n    t.\"fChief\" = '000000000000',\n    t.\"fAccountant\" = '000000000000',\n    t.\"fCashier\" = '000000000000'\n  WHERE\n    t.\"fObject\"  = :\"aObject\";\n\n  FOR SELECT\n    t.\"fObject\"\n  FROM\n    \"tPeople\" t\n  WHERE\n    t.\"fFirm\" = :\"aObject\"\n  INTO\n    :lChild\n  DO\n  BEGIN\n    EXECUTE PROCEDURE \"pPeopleDelete\"(:lChild);\n  END\n\n  FOR SELECT\n    t.\"fObject\"\n  FROM\n    \"tCargo\" t\n  WHERE\n    t.\"fFirm\" = :\"aObject\"\n  INTO\n    :lChild\n  DO\n  BEGIN\n    EXECUTE PROCEDURE \"pCargoDelete\"(:lChild);\n  END\n\n  FOR SELECT\n    t.\"fObject\"\n  FROM\n    \"tExt\" t\n  WHERE\n    t.\"fOwner\" = :\"aObject\"\n  INTO\n    :lChild\n  DO\n  BEGIN\n    EXECUTE PROCEDURE \"pExtDelete\"(:lChild);\n  END\n\n  DELETE FROM\n    \"tExtend\" x\n  WHERE\n    x.\"fOwner\" = :\"aObject\";\n\n  DELETE FROM\n    \"tFirm\" t\n  WHERE\n    t.\"fObject\" = :\"aObject\";\nEND;\n\nCOMMIT;\n\n"))

;(proc-pre-ddl "PROCEDURE pFirmDelete (aObject CHAR(12)) AS DECLARE VARIABLE lChild CHAR(12); BEGIN")
;(display-pre (list 'procedure "pFirmDelete" "ALTER PROCEDURE pFirmDelete (aObject CHAR(12)) AS DECLARE VARIABLE lChild CHAR(12); BEGIN"))
;(display-pre p1)

(regexp-match proc-head (caddr p1))

;|#