(module meta-sql
  mzscheme
  
  (require
   (prefix u. "utils.scm")
   (prefix al. "alists.scm")
   (prefix meta. "meta.scm"))
  
  (provide type-ddl
           plain-type-ddl)
  
  (define meta meta.raw_meta)
  
  (define (plain-type-ddl type)
    (if (null? type)
        ""
        (let [(first (car type))
              (next (u.safe-cadr type))]
          (string-append
           (cond
             ((and (symbol? first) (number? next))
              (format "~a(" first))
             ((and (number? first) (number? next))
              (format "~a, " first))
             ((and (number? first) (not next))
              (format "~a)" first))
             ((and (symbol? first) (not next))
              (format "~a" first))
             (else
              (format "~a " first)))
           (plain-type-ddl (cdr type))))))    
  
  (define (type-ddl type)
    (let* ([stype (if (list? type) (car type) type)]
           [plain (al.val meta 'types stype 'ddl)])
      (if plain
          (plain-type-ddl plain)
          (format "CHAR(12) /* ~a */" stype))))
  )
