(module meta-utils
  mzscheme
  
  (require (prefix meta. "meta.scm")
           "list.ss")
  
  (provide
   hlist-list
   hlist-hash
   hlist-names
   meta-get
   )
  
  (define-struct hlist (hash list))
  
  (define (hlist-names hlist)
    (map
     car
     (hlist-list hlist)))
  
  (define (hash-keys hash)
    (hash-table-map
     hash
     (lambda (key val)
       key)))
  
  (define (container? val)
    (if (pair? val)
        (if (pair? (car val))
            #t
            #f)
        (error "container? argument must be a list")))
  
  (define (make-hash-tree tree)
    (make-hlist
     (make-immutable-hash-table
      (map 
       (lambda (item)
         (let ((name (car item))
               (value (cdr item)))
           (if (container? value)
               (cons name (make-hash-tree value))
               (cons name value))))
       tree))
     tree))
  
  (define (hash-tree-get tree keys)
    (if (null? keys)
        tree
        (hash-tree-get (hash-table-get (hlist-hash tree) (car keys)) (cdr keys))))
  
  (define meta-tree (make-hash-tree (filter (lambda (item) (not (eq? (car item) 'indexes))) (cdr meta.raw_meta))))
  
  (define (meta-get . keys)
    (hash-tree-get meta-tree keys))
  
  )
