(module meta
  mzscheme
  
  (require (prefix mu. "meta-utils3.scm"))
  
  (provide meta
           raw_meta
           meta-base)
  
  (define (meta)
    raw_meta)
  
  (define meta-base
    (quasiquote
     (meta
      (version 7 0 0 225)
      (types
       (Reference
        (ddl CHAR 12))
       (Extention
        (ddl VARCHAR 750))
       (Name
        (ddl VARCHAR 30))
       (type1
        (ddl CHAR 5))
       (type2
        (ddl CHAR 5))
       (type3
        (ddl CHAR 5))
       (Boolean
        (ddl CHAR 1))
       (ShortString
        (ddl VARCHAR 30))
       (LongString
        (ddl VARCHAR 250))
       (ExtString
        (ddl VARCHAR 750))
       (MemoString
        (ddl VARCHAR 4000))
       (INN
        (ddl VARCHAR 30))
       (KPP
        (ddl VARCHAR 30))
       (BIK
        (ddl VARCHAR 15))
       (Dep
        (ddl VARCHAR 50))
       (OfkCode
        (ddl VARCHAR 10))
       (DocType
        (ddl VARCHAR 30))
       (SumMethod
        (ddl VARCHAR 30))
       (ImageName
        (ddl VARCHAR 45))
       (Date
        (ddl DATE))
       (DateTime
        (ddl TIMESTAMP))
       (Integer
        (ddl INTEGER))
       (StrNum
        (ddl VARCHAR 200))
       (Address
        (ddl VARCHAR 250))
       (WeakDocCurr
        (ddl CHAR 12))
       (CurrRate
        (ddl DOUBLE PRECISION))
       (Percent
        (ddl DOUBLE PRECISION))
       (Quantity
        (ddl DOUBLE PRECISION))
       (Money
        (ddl DOUBLE PRECISION))
       (Binary
        (ddl BLOB SUB_TYPE 0))
       (Bigint
        (ddl BIGINT))
       (OfkString
        (ddl VARCHAR 500)))
      (tables
       (Firm
        (desc "Фирмы")
        (fields
         (Self
          (type Boolean)
          (caption "Плательщик (поставщик)"))
         (ShortName
          (type ShortString)
          (caption "Фирма партнер")
          (tags def desc))
         (FullName
          (type LongString)
          (caption "Название фирмы"))
         (Address
          (caption "Адрес и телефон")
          (type Address))
         (NoNDS
          (type Boolean)
          (caption "Работа без НДС"))
         (INN
          (type INN)
          (caption "ИНН"))
         (KPP
          (caption "КПП")
          (type KPP))
         (BIK
          (caption "БИК")
          (type BIK)
          (tags select-bank))
         (Bank
          (caption "Банк")
          (type LongString)
          (tags select-bank))
         (CorDep
          (caption "Кор. счет")
          (type Dep)
          (tags select-bank))
         (RasDep
          (caption "Раcчетный счет")
          (type Dep))
         (OfkOrg
          (caption "Организация ОФК")
          (type OfkString))
         (OfkDep
          (caption "Лицевой счет клиента в ОФК")
          (type Dep))
         (OfkINN
          (caption "ИНН ОФК")
          (type INN))
         (OfkCode
          (caption "Код организации")
          (type OfkCode))
         (OfkOSB
          (caption "Отделение Сберегательного банка")
          (type LongString))
         (OfkNBudg
          (type OfkString)
          (caption "Наименование бюджета"))
         (Custom1
          (type LongString)
          (caption "Дополнительное поле 1"))
         (Custom2
          (type LongString)
          (caption "Дополнительное поле 2"))
         (Chief
          (type People)
          (caption "Руководитель"))
         (Accountant
          (type People)
          (caption "Бухгалтер"))
         (Cashier
          (type People)
          (caption "Кассир"))
         (OKPO
          (type LongString)
          (caption "ОКПО"))
         (NoSeal
          (type Boolean)
          (caption "Без печати"))
         (No2ndSign
          (type Boolean)
          (caption "Вторая подпись не предусмотрена"))
         (OfkGlavaGRS
          (type ShortString)
          (caption "Глава по БК"))
         (OfkNameUBPGRS
          (type LongString)
          (caption "Наименование ГРБС (ГАИФДБ)"))
         (OfkNameFO
          (type OfkString)
          (caption "Финансовый орган"))
         (OfkCodeOrg
          (type ShortString)
          (caption "Код органа ФК"))
         (OfkBudgLevel
          (type ShortString)
          (caption "Уровень бюджета"))
         (OfkCodeUBP
          (type ShortString)
          (caption "Код УБП"))
         (OfkNameUBP
          (type OfkString)
          (caption "Наименование УБП"))
         (IpOGRN
          (type ShortString)
          (caption "ОГРН"))
         (IpSvSer
          (type ShortString)
          (caption "Серия"))
         (IpSvNum
          (type ShortString)
          (caption "Номер"))
         (IpSvGive
          (type LongString)
          (caption "Выдано"))
         (IpSvDate
          (type Date)
          (caption "Дата выдачи"))
         (IpPspSer
          (type ShortString)
          (caption "Серия"))
         (IpPspNum
          (type ShortString)
          (caption "Номер"))
         (IpPspGive
          (type LongString)
          (caption "Выдан"))
         (IpPspDate
          (type Date)
          (caption "Дата выдачи"))
         (OKDP
          (type ShortString)
          (caption "ОКДП"))
         (ExtraName
          (type LongString)
          (caption "Полное наименование организации")
          (tags extra-fill))
         )
        (orders
         (ord0
          (fields ShortName Address))
         (ord1
          (fields FullName))
         )
        )
       (People
        (desc "Сотрудники")
        (fields
         (Firm
          (type Firm)
          (tags owner))
         (FirstName
          (type LongString)
          (caption "Имя"))
         (SecondName
          (type LongString)
          (tags def desc)
          (caption "Фамилия"))
         (LastName
          (type LongString)
          (caption "Отчество"))
         (Dutie
          (type Dutie)
          (caption "Должность"))
         (Address
          (type LongString)
          (caption "Адрес"))
         (PspSer
          (type ShortString)
          (caption "Серия"))
         (PspGive
          (type LongString)
          (caption "Выдан"))
         (PspDate
          (type Date)
          (caption "Дата выдачи"))
         (PspNum
          (type ShortString)
          (caption "Номер"))
         (TabNum
          (type LongString)
          (caption "Табельный номер"))
         (PspType
          (type LongString)
          (caption "Наименование документа"))
         (CertSer
          (type ShortString)
          (caption "Серия"))
         (CertNum
          (type ShortString)
          (caption "Номер"))
         (CertClass
          (type ShortString)
          (caption "Класс"))
         (Car
          (type Car)
          (caption "Автомобиль"))
         (CertGive
          (type LongString)
          (caption "Выдан"))
         (CertDate
          (type Date)
          (caption "Дата выдачи"))))
       (Cargo
        (desc "Грузоотправители")
        (fields
         (Firm
          (type Firm)
          (tags owner))
         (Name
          (type LongString)
          (caption "Название")
          (tags def desc))
         (INN
          (type INN)
          (caption "ИНН"))
         (KPP
          (type KPP)
          (caption "КПП"))
         (BIK
          (caption "БИК")
          (type BIK)
          (tags select-bank))
         (Bank
          (caption "Банк")
          (type LongString)
          (tags select-bank))
         (CorDep
          (caption "Кор. счет")
          (type Dep)
          (tags select-bank))
         (RasDep
          (caption "Рачетный счет")
          (type Dep))
         (OKPO
          (type LongString)
          (caption "ОКПО"))
         (Address
          (caption "Адрес и телефон")
          (type Address))))
       (Doc
        (desc "Документы")
        (fields
         (Type
          (type DocType))
         (Firm
          (type Firm))
         (FirmCargo
          (type Cargo))
         (Partner
          (type Firm))
         (PartnerCargo
          (type Cargo))
         (Date
          (type Date)
          (caption "Дата"))
         (Name
          (type StrNum)
          (tags desc))
         (Num
          (type Integer))
         (Curr
          (type WeakDocCurr))
         (ByCurr
          (type Boolean))
         ;(People
         ; (type People))
         (SumMethod
          (type SumMethod)
          (caption "Метод расчета"))
         (Precision
          (type Integer)
          (caption "Знаков после запятой"))
         (Sum
          (type Money))
         (Mark
          (type Boolean))))
       ;(Ext
       ; (fields
       ;  (Owner
       ;   (type Reference)
       ;   (tags ext-owner))
       ;  (Name
       ;   (type Name))
       ;  (Value
       ;   (type Extention))))
       (Extend
        (state extend)
        (tags extend)
        (fields
         (Owner
          (type Reference)
          (tags ext-owner))
         (V0
          (type Extention))
         (V1
          (type Extention))
         (V2
          (type Extention))
         (V3
          (type Extention))
         (V4
          (type Extention))
         (V5
          (type Extention))
         (V6
          (type Extention))
         (V7
          (type Extention))
         (V8
          (type Extention))
         (V9
          (type Extention))
         (V10
          (type Extention))
         (V11
          (type Extention))
         (V12
          (type Extention))
         (V13
          (type Extention))
         (V14
          (type Extention))
         (V15
          (type Extention))
         (V16
          (type Extention))
         (V17
          (type Extention))
         (V18
          (type Extention))
         (V19
          (type Extention))
         (V20
          (type Extention))
         (V21
          (type Extention))
         (V22
          (type Extention))
         (V23
          (type Extention))
         (V24
          (type Extention))
         (V25
          (type Extention))
         (V26
          (type Extention))
         (V27
          (type Extention))
         (V28
          (type Extention))
         (V29
          (type Extention))
         (V30
          (type Extention))
         (V31
          (type Extention))))
       (Group
        (desc "Группы товаров")
        (fields
         (Parent
          (type Reference))
         (Name
          (type LongString)
          (caption "Наименование")
          (tags def desc))
         (Print
          (type Boolean))))
       (Volume
        (desc "Единицы измерения")
        (fields
         (Name
          (type LongString)
          (caption "Наименование")
          (tags def desc))
         (OKEI
          (type LongString)
          (caption "Код по ОКЕИ"))))
       (Curr
        (desc "Дополнительные валюты")
        (fields
         (Name
          (type LongString)
          (caption "Обозначение валюты")
          (tags def desc))
         (Rate
          (type CurrRate)
          (caption "Курс"))
         (Lex_i_a
          (type LongString))
         (Lex_i_b
          (type LongString))
         (Lex_i_c
          (type LongString))
         (Lex_i_s
          (type LongString))
         (Lex_f_a
          (type LongString))
         (Lex_f_b
          (type LongString))
         (Lex_f_c
          (type LongString))
         (Lex_f_s
          (type LongString))
         (CodeOKV
          (caption "Код по ОКВ")
          (type ShortString))))
       (DocCurr
        (desc "Курсы валют в документах")
        (fields
         (Doc
          (type Doc)
          (tags owner desc))
         (Curr
          (type Curr))
         (Rate
          (type CurrRate))))
       (Model
        (desc "Модели товаров")
        (fields
         (Name
          (type LongString)
          (caption "Наименование")
          (tags def desc))
         (Price
          (type Money)
          (caption "Цена"))
         (NDS
          (type Percent)
          (caption "НДС"))
         (NDSMode
          (type Integer)
          (caption "выделить"))
         (Group
          (type Group)
          (caption "Группа"))
         (Volume
          (type Volume)
          (caption "Ед. изм."))
         (Curr
          (type Curr)
          (caption "Валюта"))
         (GTD
          (type LongString)
          (caption "ГТД"))
         (Country
          (type Country)
          (caption "Страна"))
         (Note1
          (type LongString)
          (caption "Примечание 1"))
         (Note2
          (type LongString)
          (caption "Примечание 2"))
         (Pack
          (type Volume)
          (caption "Упаковка"))
         (Coefficient
          (type Quantity)
          (caption "Коэффициент"))
         ))
       (Goods
        (desc "Товары в документах")
        (fields
         (Doc
          (type Doc)
          (tags owner desc))
         (Count
          (type Quantity)
          (caption "Количество"))
         (Price
          (type Money)
          (caption "Цена"))
         (NDS
          (type Percent)
          (caption "НДС"))
         (NDSMode
          (type Integer)
          (caption "выделить"))
         (Model
          (type Model)
          (caption "Наименование"))
         (QName
          (type LongString)
          (tags hide-select)
          ;(caption "sss")
          )
         (OrderA
          (type Integer))
         
         (Volume
          (type Volume)
          (caption "Ед. изм."))
         (GTD
          (type LongString)
          (caption "ГТД"))
         (Country
          (type Country)
          (caption "Страна"))
         (Pack
          (type Volume)
          (caption "Упаковка"))
         (Coefficient
          (type Quantity)
          (caption "Коэффициент"))
         (PriceDC ; цена в валюте документа
          (type Money))
         ))
       (Payment
        (desc "Оплаты")
        (fields
         (Doc
          (type Doc)
          (tags owner desc))
         (Desc
          (type LongString)
          (caption "Описание"))
         (Date
          (type Date)
          (caption "Дата"))
         (Sum
          (type Money)
          (caption "Сумма"))
         (Curr
          (type Curr)
          (caption "Валюта"))))
       (Template
        (desc "Шаблоны")
        (fields
         (Type
          (type ShortString))          
         (Field
          (type ShortString))
         (Content
          (type MemoString)
          (tags desc))))
       (Dutie
        (desc "Должности")
        (fields
         (Name
          (type LongString)
          (tags desc)
          (caption "Наименование"))))
       (Country
        (desc "Страны")
        (fields
         (Name
          (type LongString)
          (caption "Наименование")
          (tags desc))))
       (ClassCode
        (desc "Коды классификации")
        (fields
         (Doc
          (type Doc)
          (tags owner desc))
         (Formed
          (type LongString))
         (GLAVA
          (type LongString))
         (RAZDEL
          (type LongString))
         (STATIA
          (type LongString))
         (VID
          (type LongString))
         (KOD_FP
          (type LongString))
         (E_KLASS
          (type LongString))
         (KKIVNF
          (type LongString))
         (KKIVF
          (type LongString))
         (KDOH
          (type LongString))
         (NUM_BO
          (type LongString))
         (MON_FIN
          (type LongString))
         (SUM_STR
          (type Money))
         (FOND_P
          (type LongString))
         (OFK_DEP
          (type LongString))
         (ADD_KLASS
          (type LongString))
         (KOD_FIN
          (type LongString))
         ))
       (Custom
        (desc "Дополнительные значения")
        (fields
         (Field1
          (type LongString)
          (tags desc))
         (Page
          (type LongString))
         ))
       (Attach
        (desc "Вложения")
        (tags extend)
        (fields
         (Owner
          (type Reference))
         (Class
          (type ShortString))
         (Name
          (type LongString)
          (tags desc))
         (Content
          (type Binary))
         (Size
          (type Integer))
         (State
          (type Integer))
         ))
       (SubDoc
        (desc "Платежи в заявке кассового расхода")
        (fields
         (Doc
          (type Doc)
          (tags owner desc))
         (Sum
          (type Money)
          (caption "Сумма"))
         (NDS
          (type Percent)
          (caption "НДС"))
         (NDSMode
          (type Integer)
          (caption "выделить"))
         (TypeAP
          (type Boolean)
          ;(caption "Признак авансового платежа")
          )
         (OrderPL
          (type ShortString)
          ;(caption "Очередность платежа")
          )
         (VidPL
          (type ShortString)
          ;(caption "Вид платежа")
          )
         (Purpose
          (type LongString)
          ;(caption "Назначение платежа (примечание)")
          (tags template))
         (VidOsn
          (type LongString)
          (caption "Вид"))
         (NumOsn
          (type ShortString)
          (caption "Номер"))
         (DateOsn
          (type Date)
          (caption "Дата"))
         (Osn
          (type LongString)
          (caption "Предмет"))
         (Partner
          (type Firm))
         (PartnerCargo
          (type Cargo))
         (PayStatus
          (type ShortString)
          (caption "Статус налогоплательщика"))
         (KDOH
          (type KBK)
          (caption "Код по БК"))
         (OKATO
          (type Okato)
          (caption "Код ОКАТО"))
         (OsnPL
          (type ShortString)
          (caption "Основание платежа"))
         (NalPer
          (type ShortString)
          (caption "Налоговый период"))
         (NumDok
          (type ShortString)
          (caption "Номер документа"))
         (DateDok
          (type Date)
          (caption "Дата документа"))
         (TypePL
          (type ShortString)
          (caption "Тип платежа"))
         (CodeIstKBK
          (type ShortString)
          (caption "Источник средств"))
         (TypeKBKPay
          (type ShortString)
          (caption "Тип КБК плательщика"))
         (KBKPay
          (type KBK)
          (caption "Код по БК плательщика"))
         (TypeKBKRcp
          (type ShortString)
          (caption "Тип КБК получателя"))
         (KBKRcp
          (type KBK)
          (caption "Код по БК получателя"))
         (PurposeKBK
          (type LongString)
          (caption "Назначение платежа")
          (tags template))
         (NoteKBK
          (type LongString)
          (caption "Примечание")
          (tags template))
         (OrderA
          (type Integer))
         (AddKlassPay
          (type ShortString)
          (caption "Код цели субсидии/субвенции плательщика"))
         (AddKlassRcp
          (type ShortString)
          (caption "Код цели субсидии/субвенции получателя"))
         ))
       (Expense
        (desc "Расходы авансовых платежей")
        (fields
         (Doc
          (type Doc)
          (tags owner))
         (Date
          (type Date)
          (caption "Дата"))
         (Number
          (type StrNum)
          (caption "Номер"))
         (Name
          (type LongString)
          (caption "Наименование")
          (tags desc))
         (SumVN
          (type Money)
          ;(caption "По отчету руб.")
          )
         (SumRN
          (type Money)
          ;(caption "Принято к учету руб.")
          )
         (DinV
          (type ShortString)
          (caption "Дебет счета"))
         (CinV
          (type ShortString)
          (caption "Кредит счета"))
         (OrderA
          (type Integer))
         ))
       (MutualRef
        (desc "Общие ссылки")
        (tags extend)
        (fields
         (Owner0
          (type Reference)
          (tags ext-owner))
         (Owner1
          (type Reference))
         (Name
          (type LongString)
          (tags desc))
         (Value
          (type Reference))))
       ;(Default
       ; (fields
       ;  (Owner
       ;   (type Reference))
       ;  (Name
       ;   (type LongString))
       ;  (Value
       ;   (type Extention))))
       (Okato
        (desc "Коды ОКАТО")
        (fields
         (Name
          (type ShortString)
          (tags desc)
          (caption "Наименование"))))
       (KBK
        (desc "Коды бюджетной классификации")
        (fields
         (Name
          (type ShortString)
          (tags desc)
          (caption "Наименование"))
         (TypeKBK
          (type ShortString))
         (Desc
          (caption "Примечание")
          (type ShortString))))
       (Bank
        (desc "Реквизиты банков")
        (fields
         (Name
          (type LongString)
          (tags desc))
         (BIK
          (type BIK))
         (CorDep
          (type Dep))))
       (SubDocR
        (desc "Заявка на получение наличных денег")
        (fields
         (Doc
          (type Doc)
          (tags owner desc))
         (SumR
          (type Money)
          (caption "Сумма в рублях"))
         (CheckNum
          (type ShortString)
          (caption "Номер чека"))
         (CheckSer
          (type ShortString)
          (caption "Серия чека"))
         (CheckDate
          (type Date)
          (caption "Дата чека"))
         (CheckDateLim
          (type Date)
          (caption "Срок действия чека"))
         (CheckKas
          (type ShortString)
          (caption "Символ кассового плана"))
         (CodeIst
          (type ShortString)
          (caption "Источник средств"))
         (KBK
          (type KBK)
          (caption "Код по КБК"))
         (TypeKBK
          (type ShortString)
          (caption "Тип КБК"))
         (AddKlass
          (type ShortString)
          (caption "Код цели"))
         (SumRKBK
          (type Money)
          (caption "Сумма"))
         (Purpose
          (type LongString)
          (caption "Назначение платежа"))
         (Note
          (type LongString)
          (caption "Примечание"))
         (OrderA
          (type Integer))))
       (SubSubDocR
        (desc "Расшифровка заявки на получение наличных денег")
        (fields
         (SubDocR
          (type SubDocR)
          (tags owner desc))
         (CodeIst
          (type ShortString)
          (caption "Источник средств"))
         (KBK
          (type KBK)
          (caption "Код по КБК"))
         (TypeKBK
          (type ShortString)
          (caption "Тип КБК"))
         (AddKlass
          (type ShortString)
          (caption "Код цели"))
         (SumRKBK
          (type Money)
          (caption "Сумма"))
         (Purpose
          (type LongString)
          (caption "Назначение платежа"))
         (Note
          (type LongString)
          (caption "Примечание"))
         (OrderA
          (type Integer))))
       (Car
        (desc "Автомобили")
        (fields
         (Firm
          (type Firm)
          (tags owner))
         (Mark
          (type LongString)
          (caption "Марка"))
         (StateNum
          (type LongString)
          (tags desc)
          (caption "Государственный номерной знак"))
         (GarageNum
          (type LongString)
          (caption "Гаражный номер"))
         (Type
          (type ShortString))
         (Model
          (type ShortString)
          (caption "Модель"))
         (ReleaseYear
          (type ShortString)
          (caption "Год выпуска"))
         (Engine
          (type ShortString)
          (caption "Двигатель №"))
         (Chassis
          (type ShortString)
          (caption "Шасси №"))
         (Body
          (type ShortString)
          (caption "Кузов №"))
         (VIN
          (type ShortString)
          (caption "Идентификационный номер (VIN)"))
         (Color
          (type ShortString)
          (caption "Цвет"))
         (PspSer
          (type ShortString)
          (caption "Серия"))
         (PspNum
          (type ShortString)
          (caption "Номер"))
         (CertSer
          (type ShortString)
          (caption "Серия"))
         (CertNum
          (type ShortString)
          (caption "Номер"))
         (CertDate
          (type Date)
          (caption "Дата выдачи"))
         (CertGive
          (type LongString)
          (caption "Выдано"))))
       (GoodsC
        (desc "Сведения о грузе")
        (fields
         (Doc
          (type Doc)
          (tags owner))
         (Name
          (type LongString)
          (caption "Краткое описание груза"))
         (Note
          (type LongString)
          (caption "С грузом следуют документы"))
         (PackType
          (type ShortString)
          (caption "Вид упаковки"))
         (PackNum
          (type Quantity)
          (caption "Количество мест"))
         (MassMode
          (type ShortString)
          (caption "Способ определения массы"))
         (Code
          (type ShortString)
          (caption "Код груза"))
         (Container
          (type ShortString)
          (caption "Номер контейнера"))
         (Class
          (type ShortString)
          (caption "Класс груза"))
         (Mass
          (type Quantity)
          (caption "Масса брутто"))
         (OrderA
          (type Integer))))
       (CalcMethod
        (desc "Способы расчета сумм")
        (fields
         (Name
          (type LongString)
          (caption "Название"))
         (Method
          (type MemoString)
          (caption "Метод"))))
       (UidMap
        (desc "Таблица соответствия идентификаторов")
        (fields
         (Class
          (type ShortString))
         (Key
          (type Reference))
         (Value
          (type Reference))))
       )
      
      (indexes
       (Doc
        (Type Num)
        (Curr)
        (Date))
       (People
        (FirstName))
       (MutualRef
        (Owner0 Owner1)
        (Owner1)
        (Value))
       (LazyCopy
        (Owner)
        (Object))
       (Object
        (Lazy)
        (Age))
       (UidMap
        (Key)
        (Value))
       )
      
      )))
  
  (define meta-over
    (with-handlers ([exn:fail?
                     (lambda (exn) #f)])
      (dynamic-require "meta-over.scm" 'meta-over)))
  
  (define raw_meta
    (if meta-over
        (mu.merge-over meta-base meta-over)
        meta-base))
  
  )
