(module pv-utils
  mzscheme
  
  (provide
   insert-after
   insert-between
   any-list->string-list
   string-list->string
   flatten
   
   list-has?
   and?
   or?
   cnot
   comb)
  
  (define (insert-after a-list a-delim) ; insert a-delim after each item of a-list
    (if (null? a-list)
        null
        (cons
         (car a-list)
         (cons
          a-delim
          (insert-after (cdr a-list) a-delim)))))
  
  (define (insert-between a-list a-delim)
    (if (null? a-list)
        (error "list expected")
        (cons
         (car a-list)
         (if (null? (cdr a-list))
             null
             (cons
              a-delim
              (insert-between (cdr a-list) a-delim))))))
  
  ;(insert-between (list 1 2 3 4 5 6 7) 11)
  
  (define (flatten a-list) ; convert list of lists to single list - version 2
    (apply append a-list))

  (define (any->string any)
    (cond
      ((symbol? any) (symbol->string any))
      ((number? any) (number->string any))
      ((string? any) any)
      (else (error "any->string: unknown value"))))
  
  (define (any-list->string-list any-list)
    (map
     any->string
     any-list))
  
  (define (string-list->string a-list)
    (if (null? a-list)
        ""
        (string-append (car a-list) (string-list->string (cdr a-list)))))
  
  (define (list-has? a-list a-test)
    (if (null? a-list)
        #f
        (if (eq? (car a-list) a-test)
            #t
            (list-has? (cdr a-list) a-test))))
  
  (define (and? . v)
    (not (list-has? v #f)))
  
  (define (or? . v)
    (list-has? v #t))
  
  (define (cnot func)
    (lambda params
      (not (apply func params))))
  
  (define (comb op . functions)
    (lambda params
      (apply op (map (lambda (function) (apply function params)) functions))))
  
  )