(module sql-utils-lazy3
  mzscheme
  
  (require "utils.scm"
           "meta-utils3.scm"
           (prefix meta. "meta.scm")
           (prefix al. "alists.scm"))
  
  (provide ;display-pre
   ;display-post
   proc-get-lazy-ddl3
   proc-all-get-lazy-ddl3)
  
  (define meta meta.raw_meta)
  
  (define t-proc 'procedure)
  
  (define (proc-get-lazy-ddl3 name)
    (let* ([table (al.node meta 'tables name)]
           [owner (get-owner-field table)])
      (list t-proc (format "p~aGetLazy" name)
            (mix
             "ALTER PROCEDURE \"p" name "GetLazy\"(aObject CHAR(12))" br
             "  RETURNS (\"oLazy\" INTEGER)" br
             "AS" br
             (if owner (mix "  DECLARE VARIABLE lOwner CHAR(12);" br) "")
             "BEGIN" br
             "  SELECT \"fLazy\" FROM \"tObject\" WHERE \"UID\" = :aObject INTO :\"oLazy\";" br
             (if owner
                 (let ([fname (car owner)])
                   (if (not (eq? name 'Payment))
                       (mix
                        "  IF (\"oLazy\" = 0) THEN" br
                        "  BEGIN" br
                        "    SELECT \"f" fname "\" FROM \"t" name "\" WHERE \"fObject\" = :aObject INTO lOwner;" br
                        "    SELECT \"oLazy\" FROM \"pGetLazy\"(:lOwner) INTO :\"oLazy\";" br
                        "  END" br)
                       (mix "  /* changing payments do not change document, there do not need check lazy state of owner doc */" br)))
                 "")
             "  SUSPEND;" br
             "END;"))))
  
  (define (proc-all-get-lazy-ddl3)
    (list t-proc "pGetLazy"
          (mix
           "ALTER PROCEDURE \"pGetLazy\"(aObject CHAR(12))" br
           "  RETURNS (\"oLazy\" INTEGER)" br
           "AS" br
           "  DECLARE VARIABLE lTable VARCHAR(30);" br
           "BEGIN" br
           "  SELECT \"fTable\" FROM \"tObject\" WHERE \"UID\" = :aObject INTO lTable;" br
           "  IF (lTable IS NULL) THEN" br
           "    EXCEPTION ERR 'pGetLazy: object \"' || COALESCE(aObject, 'unknown') || '\" not found';" br
           (apply 
            string-append 
            (map (lambda (table)
                   (mix
                    "  IF (lTable = '" table "') THEN" br
                    "    SELECT \"oLazy\" FROM \"p" table "GetLazy\"(:aObject) INTO :\"oLazy\";" br
                    "  ELSE" br))
                 (map car (al.val meta 'tables))))
           "    EXCEPTION ERR 'pGetLazy: table \"' || COALESCE(lTable, 'unknown') || '\" not defined';" br
           "  SUSPEND;" br
           "END;")))
  
  )
