(module table-utils
  mzscheme
  
  (provide fields-num
           field-index
           table-rows-by-name)
  
  (define (fields-num fields)
    
    (define (f-n fields num)
      (if (null? fields)
          null
          (cons (list (car fields) num)
                (f-n (cdr fields) (+ num 1)))))
    
    (f-n fields 0))
  
  (define (field-index table)
    (let* ([fields (car table)]
           [fields-n (fields-num fields)]
           [fields-h (make-immutable-hash-table fields-n)])
      (lambda (field)
        (car (hash-table-get fields-h field)))))
  
  (define (table-rows-by-name table)
    (let ([f-i (field-index table)]
          [rows (cadr table)])
      (map (lambda (row)
             (lambda (field-name); row value by name
               (vector-ref row (f-i field-name))))
           rows)))
  
  )